/**********************************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IRecorderWizardPage.java,v 1.6 2008-03-13 17:01:41 paules Exp $
 * 
 * Contributors: 
 * IBM Corporation - initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.internal.execution.recorder.ui.wizards;

import org.eclipse.hyades.internal.execution.testgen.ui.wizards.ITestGenWizardPage;

/**
 * Interface for wizard pages which will be a part of a RecorderWizard
 * @author Ernest Jessee
 * @deprecated - use IGenericRecorderPage and Generic Recorder Framework
 */

public interface IRecorderWizardPage extends ITestGenWizardPage
{
	/**
	 * called for the wizard page to save it's information in the preferance store.
	 */
	public void saveSettings();
	
	/**
	 * should return the context sensitive help id for this wizard page
	 */
	public abstract String getContextHelpID();
	
}
