/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CFGComparablePropertyImpl.java,v 1.10 2009-05-05 15:46:20 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.models.common.configuration.CFGCategory;
import org.eclipse.hyades.models.common.configuration.CFGComparableProperty;
import org.eclipse.hyades.models.common.configuration.CFGPropertyGroup;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.interactions.impl.BVRPropertyImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CFG Comparable Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl#getOperator <em>Operator</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGComparablePropertyImpl#getSubPropertyGroups <em>Sub Property Groups</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CFGComparablePropertyImpl extends BVRPropertyImpl implements CFGComparableProperty {
	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected CFGCategory type;

	/**
	 * The default value of the '{@link #getOperator() <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperator()
	 * @generated
	 * @ordered
	 */
	protected static final String OPERATOR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOperator() <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperator()
	 * @generated
	 * @ordered
	 */
	protected String operator = OPERATOR_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSubPropertyGroups() <em>Sub Property Groups</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubPropertyGroups()
	 * @generated
	 * @ordered
	 */
	protected EList<CFGPropertyGroup> subPropertyGroups;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CFGComparablePropertyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return Common_ConfigurationPackage.Literals.CFG_COMPARABLE_PROPERTY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGCategory getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetType(CFGCategory newType, NotificationChain msgs) {
		CFGCategory oldType = type;
		type = newType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE, oldType, newType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(CFGCategory newType) {
		if (newType != type) {
			NotificationChain msgs = null;
			if (type != null)
				msgs = ((InternalEObject)type).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE, null, msgs);
			if (newType != null)
				msgs = ((InternalEObject)newType).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE, null, msgs);
			msgs = basicSetType(newType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE, newType, newType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CFGPropertyGroup> getSubPropertyGroups() {
		if (subPropertyGroups == null) {
			subPropertyGroups = new EObjectContainmentEList<CFGPropertyGroup>(CFGPropertyGroup.class, this, Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS);
		}
		return subPropertyGroups;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE:
				return basicSetType(null, msgs);
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS:
				return ((InternalEList<?>)getSubPropertyGroups()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE:
				return getType();
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__OPERATOR:
				return getOperator();
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS:
				return getSubPropertyGroups();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE:
				setType((CFGCategory)newValue);
				return;
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__OPERATOR:
				setOperator((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS:
				getSubPropertyGroups().clear();
				getSubPropertyGroups().addAll((Collection<? extends CFGPropertyGroup>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE:
				setType((CFGCategory)null);
				return;
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__OPERATOR:
				setOperator(OPERATOR_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS:
				getSubPropertyGroups().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__TYPE:
				return type != null;
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__OPERATOR:
				return OPERATOR_EDEFAULT == null ? operator != null : !OPERATOR_EDEFAULT.equals(operator);
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__SUB_PROPERTY_GROUPS:
				return subPropertyGroups != null && !subPropertyGroups.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOperator() {
		return operator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOperator(String newOperator) {
		String oldOperator = operator;
		operator = newOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY__OPERATOR, oldOperator, operator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (operator: ");
		result.append(operator);
		result.append(')');
		return result.toString();
	}

} //CFGComparablePropertyImpl
