/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: BVRGeneralOrderingImpl.java,v 1.9 2009-05-05 15:49:18 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.interactions.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRGeneralOrdering;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR General Ordering</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRGeneralOrderingImpl#getPreviousEventOccurrence <em>Previous Event Occurrence</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRGeneralOrderingImpl#getNextEventOccurence <em>Next Event Occurence</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVRGeneralOrderingImpl extends EObjectImpl implements BVRGeneralOrdering
{
	/**
	 * The cached value of the '{@link #getPreviousEventOccurrence() <em>Previous Event Occurrence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPreviousEventOccurrence()
	 * @generated
	 * @ordered
	 */
	protected BVREventOccurrence previousEventOccurrence;

	/**
	 * The cached value of the '{@link #getNextEventOccurence() <em>Next Event Occurence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNextEventOccurence()
	 * @generated
	 * @ordered
	 */
	protected BVREventOccurrence nextEventOccurence;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVRGeneralOrderingImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return Common_Behavior_InteractionsPackage.Literals.BVR_GENERAL_ORDERING;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVREventOccurrence getPreviousEventOccurrence() {
		if (previousEventOccurrence != null && previousEventOccurrence.eIsProxy()) {
			InternalEObject oldPreviousEventOccurrence = (InternalEObject)previousEventOccurrence;
			previousEventOccurrence = (BVREventOccurrence)eResolveProxy(oldPreviousEventOccurrence);
			if (previousEventOccurrence != oldPreviousEventOccurrence) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE, oldPreviousEventOccurrence, previousEventOccurrence));
			}
		}
		return previousEventOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVREventOccurrence basicGetPreviousEventOccurrence() {
		return previousEventOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPreviousEventOccurrence(BVREventOccurrence newPreviousEventOccurrence, NotificationChain msgs) {
		BVREventOccurrence oldPreviousEventOccurrence = previousEventOccurrence;
		previousEventOccurrence = newPreviousEventOccurrence;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE, oldPreviousEventOccurrence, newPreviousEventOccurrence);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPreviousEventOccurrence(BVREventOccurrence newPreviousEventOccurrence) {
		if (newPreviousEventOccurrence != previousEventOccurrence) {
			NotificationChain msgs = null;
			if (previousEventOccurrence != null)
				msgs = ((InternalEObject)previousEventOccurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
			if (newPreviousEventOccurrence != null)
				msgs = ((InternalEObject)newPreviousEventOccurrence).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
			msgs = basicSetPreviousEventOccurrence(newPreviousEventOccurrence, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE, newPreviousEventOccurrence, newPreviousEventOccurrence));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVREventOccurrence getNextEventOccurence() {
		if (nextEventOccurence != null && nextEventOccurence.eIsProxy()) {
			InternalEObject oldNextEventOccurence = (InternalEObject)nextEventOccurence;
			nextEventOccurence = (BVREventOccurrence)eResolveProxy(oldNextEventOccurence);
			if (nextEventOccurence != oldNextEventOccurence) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE, oldNextEventOccurence, nextEventOccurence));
			}
		}
		return nextEventOccurence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVREventOccurrence basicGetNextEventOccurence() {
		return nextEventOccurence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNextEventOccurence(BVREventOccurrence newNextEventOccurence, NotificationChain msgs) {
		BVREventOccurrence oldNextEventOccurence = nextEventOccurence;
		nextEventOccurence = newNextEventOccurence;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE, oldNextEventOccurence, newNextEventOccurence);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNextEventOccurence(BVREventOccurrence newNextEventOccurence) {
		if (newNextEventOccurence != nextEventOccurence) {
			NotificationChain msgs = null;
			if (nextEventOccurence != null)
				msgs = ((InternalEObject)nextEventOccurence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
			if (newNextEventOccurence != null)
				msgs = ((InternalEObject)newNextEventOccurence).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
			msgs = basicSetNextEventOccurence(newNextEventOccurence, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE, newNextEventOccurence, newNextEventOccurence));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				if (previousEventOccurrence != null)
					msgs = ((InternalEObject)previousEventOccurrence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__TARGET_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
				return basicSetPreviousEventOccurrence((BVREventOccurrence)otherEnd, msgs);
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				if (nextEventOccurence != null)
					msgs = ((InternalEObject)nextEventOccurence).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE__SOURCE_GENERAL_ORDERINGS, BVREventOccurrence.class, msgs);
				return basicSetNextEventOccurence((BVREventOccurrence)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				return basicSetPreviousEventOccurrence(null, msgs);
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				return basicSetNextEventOccurence(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				if (resolve) return getPreviousEventOccurrence();
				return basicGetPreviousEventOccurrence();
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				if (resolve) return getNextEventOccurence();
				return basicGetNextEventOccurence();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				setPreviousEventOccurrence((BVREventOccurrence)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				setNextEventOccurence((BVREventOccurrence)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				setPreviousEventOccurrence((BVREventOccurrence)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				setNextEventOccurence((BVREventOccurrence)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__PREVIOUS_EVENT_OCCURRENCE:
				return previousEventOccurrence != null;
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING__NEXT_EVENT_OCCURENCE:
				return nextEventOccurence != null;
		}
		return super.eIsSet(featureID);
	}

} //BVRGeneralOrderingImpl
