/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TPFDefaultApplication.java,v 1.9 2009-05-05 15:49:17 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TPF Default Application</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A default application is the a reference to a default behavior, owned by an element deifining its scope. This allows the default to be activated should an unexpected event occur on a component, based on its scope.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getTestComponent <em>Test Component</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getMessageEnd <em>Message End</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getLifeline <em>Lifeline</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getInteractionFragment <em>Interaction Fragment</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getDefault <em>Default</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication()
 * @model
 * @generated
 */
public interface TPFDefaultApplication extends EObject{
	/**
	 * Returns the value of the '<em><b>Test Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Test Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Test Component</em>' reference.
	 * @see #setTestComponent(TPFTestComponent)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication_TestComponent()
	 * @model
	 * @generated
	 */
	TPFTestComponent getTestComponent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getTestComponent <em>Test Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Test Component</em>' reference.
	 * @see #getTestComponent()
	 * @generated
	 */
	void setTestComponent(TPFTestComponent value);

	/**
	 * Returns the value of the '<em><b>Message End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Message End</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Message End</em>' reference.
	 * @see #setMessageEnd(BVRMessageEnd)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication_MessageEnd()
	 * @model
	 * @generated
	 */
	BVRMessageEnd getMessageEnd();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getMessageEnd <em>Message End</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Message End</em>' reference.
	 * @see #getMessageEnd()
	 * @generated
	 */
	void setMessageEnd(BVRMessageEnd value);

	/**
	 * Returns the value of the '<em><b>Lifeline</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lifeline</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lifeline</em>' reference.
	 * @see #setLifeline(BVRLifeline)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication_Lifeline()
	 * @model
	 * @generated
	 */
	BVRLifeline getLifeline();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getLifeline <em>Lifeline</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lifeline</em>' reference.
	 * @see #getLifeline()
	 * @generated
	 */
	void setLifeline(BVRLifeline value);

	/**
	 * Returns the value of the '<em><b>Interaction Fragment</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.interactions.BVRInteractionFragment#getDefaultApplication <em>Default Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interaction Fragment</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interaction Fragment</em>' container reference.
	 * @see #setInteractionFragment(BVRInteractionFragment)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication_InteractionFragment()
	 * @see org.eclipse.hyades.models.common.interactions.BVRInteractionFragment#getDefaultApplication
	 * @model opposite="defaultApplication"
	 * @generated
	 */
	BVRInteractionFragment getInteractionFragment();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getInteractionFragment <em>Interaction Fragment</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interaction Fragment</em>' container reference.
	 * @see #getInteractionFragment()
	 * @generated
	 */
	void setInteractionFragment(BVRInteractionFragment value);

	/**
	 * Returns the value of the '<em><b>Default</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFDefault#getDefaultApplications <em>Default Applications</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default</em>' reference.
	 * @see #setDefault(TPFDefault)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFDefaultApplication_Default()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDefault#getDefaultApplications
	 * @model opposite="defaultApplications" required="true"
	 * @generated
	 */
	TPFDefault getDefault();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication#getDefault <em>Default</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default</em>' reference.
	 * @see #getDefault()
	 * @generated
	 */
	void setDefault(TPFDefault value);

} // TPFDefaultApplication
