/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TPFInvocationEvent.java,v 1.9 2009-05-05 15:49:17 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TPF Invocation Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getStatus <em>Status</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getReason <em>Reason</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getInvokedExecutionResult <em>Invoked Execution Result</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationEvent()
 * @model
 * @generated
 */
public interface TPFInvocationEvent extends TPFExecutionEvent{
	/**
	 * Returns the value of the '<em><b>Status</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.common.testprofile.TPFInvocationStatus}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Status</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Status</em>' attribute.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationStatus
	 * @see #setStatus(TPFInvocationStatus)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationEvent_Status()
	 * @model
	 * @generated
	 */
	TPFInvocationStatus getStatus();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getStatus <em>Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Status</em>' attribute.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationStatus
	 * @see #getStatus()
	 * @generated
	 */
	void setStatus(TPFInvocationStatus value);

	/**
	 * Returns the value of the '<em><b>Reason</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.common.testprofile.TPFInvocationReason}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reason</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reason</em>' attribute.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationReason
	 * @see #setReason(TPFInvocationReason)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationEvent_Reason()
	 * @model
	 * @generated
	 */
	TPFInvocationReason getReason();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getReason <em>Reason</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reason</em>' attribute.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationReason
	 * @see #getReason()
	 * @generated
	 */
	void setReason(TPFInvocationReason value);

	/**
	 * Returns the value of the '<em><b>Invoked Execution Result</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionResult#getInvocationExecutionEvent <em>Invocation Execution Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Invoked Execution Result</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Invoked Execution Result</em>' containment reference.
	 * @see #setInvokedExecutionResult(TPFExecutionResult)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationEvent_InvokedExecutionResult()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionResult#getInvocationExecutionEvent
	 * @model opposite="invocationExecutionEvent" containment="true"
	 * @generated
	 */
	TPFExecutionResult getInvokedExecutionResult();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent#getInvokedExecutionResult <em>Invoked Execution Result</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Invoked Execution Result</em>' containment reference.
	 * @see #getInvokedExecutionResult()
	 * @generated
	 */
	void setInvokedExecutionResult(TPFExecutionResult value);

} // TPFInvocationEvent
