/**********************************************************************
 * Copyright (c) 2003, 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCFullTraceObject.java,v 1.7 2006-02-08 19:56:59 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.trace;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Full Trace Object</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCreateTime <em>Create Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCollectTime <em>Collect Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getBaseTime <em>Base Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCumulativeTime <em>Cumulative Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCalls <em>Calls</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getObjAllocSite <em>Obj Alloc Site</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject()
 * @model
 * @generated
 */
public interface TRCFullTraceObject extends TRCTraceObject {
	/**
	 * Returns the value of the '<em><b>Create Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Create Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * When the object was created (allocated), relative to hierarchy.TRCAgent.startTime
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Create Time</em>' attribute.
	 * @see #setCreateTime(double)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_CreateTime()
	 * @model
	 * @generated
	 */
	double getCreateTime();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCreateTime <em>Create Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Create Time</em>' attribute.
	 * @see #getCreateTime()
	 * @generated
	 */
	void setCreateTime(double value);

	/**
	 * Returns the value of the '<em><b>Collect Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Collect Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * When the object was collected by GC, relative to hierarchy.TRCAgent.startTime
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Collect Time</em>' attribute.
	 * @see #setCollectTime(double)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_CollectTime()
	 * @model
	 * @generated
	 */
	double getCollectTime();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCollectTime <em>Collect Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Collect Time</em>' attribute.
	 * @see #getCollectTime()
	 * @generated
	 */
	void setCollectTime(double value);

	/**
	 * Returns the value of the '<em><b>Base Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Base Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Time spent in methods of the owning element
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Base Time</em>' attribute.
	 * @see #setBaseTime(double)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_BaseTime()
	 * @model
	 * @generated
	 */
	double getBaseTime();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getBaseTime <em>Base Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Base Time</em>' attribute.
	 * @see #getBaseTime()
	 * @generated
	 */
	void setBaseTime(double value);
	
	void incrementBaseTime(double value);

	/**
	 * Returns the value of the '<em><b>Cumulative Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cumulative Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Time spent in methods of this owning element + all methods called from these methods (but owned by other elements)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Cumulative Time</em>' attribute.
	 * @see #setCumulativeTime(double)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_CumulativeTime()
	 * @model
	 * @generated
	 */
	double getCumulativeTime();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCumulativeTime <em>Cumulative Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cumulative Time</em>' attribute.
	 * @see #getCumulativeTime()
	 * @generated
	 */
	void setCumulativeTime(double value);

	public void incrementCumulativeTime(double time);
	
	/**
	 * Returns the value of the '<em><b>Calls</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Calls</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * number of calls to the owning element
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Calls</em>' attribute.
	 * @see #setCalls(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_Calls()
	 * @model
	 * @generated
	 */
	int getCalls();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getCalls <em>Calls</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Calls</em>' attribute.
	 * @see #getCalls()
	 * @generated
	 */
	void setCalls(int value);

	/**
	 * Returns the value of the '<em><b>Obj Alloc Site</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Obj Alloc Site</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Obj Alloc Site</em>' reference.
	 * @see #setObjAllocSite(TRCObjAllocSite)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCFullTraceObject_ObjAllocSite()
	 * @model
	 * @generated
	 */
	TRCObjAllocSite getObjAllocSite();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCFullTraceObject#getObjAllocSite <em>Obj Alloc Site</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Obj Alloc Site</em>' reference.
	 * @see #getObjAllocSite()
	 * @generated
	 */
	void setObjAllocSite(TRCObjAllocSite value);

} // TRCFullTraceObject
