/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Preferences.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Preferences.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Preferences</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getBrowserCookieName <em>Browser Cookie Name</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#isShow <em>Show</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getStoredPreferences <em>Stored Preferences</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getUpdatedPreferencesVariable <em>Updated Preferences Variable</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getTooltip <em>Tooltip</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface Preferences {
	/**
	 * Returns the value of the '<em><b>Browser Cookie Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Browser Cookie Name</em>' attribute.
	 * @see #setBrowserCookieName(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_BrowserCookieName()
	 * @model 
	 * @generated
	 */
	String getBrowserCookieName();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getBrowserCookieName <em>Browser Cookie Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Browser Cookie Name</em>' attribute.
	 * @see #getBrowserCookieName()
	 * @generated
	 */
	void setBrowserCookieName(String value);

	/**
	 * Returns the value of the '<em><b>Show</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show</em>' attribute.
	 * @see #isSetShow()
	 * @see #unsetShow()
	 * @see #setShow(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_Show()
	 * @model default="false" unsettable="true"
	 * @generated
	 */
	boolean isShow();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#isShow <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show</em>' attribute.
	 * @see #isSetShow()
	 * @see #unsetShow()
	 * @see #isShow()
	 * @generated
	 */
	void setShow(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#isShow <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetShow()
	 * @see #isShow()
	 * @see #setShow(boolean)
	 * @generated
	 */
	void unsetShow();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#isShow <em>Show</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Show</em>' attribute is set.
	 * @see #unsetShow()
	 * @see #isShow()
	 * @see #setShow(boolean)
	 * @generated
	 */
	boolean isSetShow();

	/**
	 * Returns the value of the '<em><b>Stored Preferences</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stored Preferences</em>' attribute.
	 * @see #setStoredPreferences(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_StoredPreferences()
	 * @model 
	 * @generated
	 */
	String getStoredPreferences();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getStoredPreferences <em>Stored Preferences</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stored Preferences</em>' attribute.
	 * @see #getStoredPreferences()
	 * @generated
	 */
	void setStoredPreferences(String value);

	/**
	 * Returns the value of the '<em><b>Updated Preferences Variable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Updated Preferences Variable</em>' attribute.
	 * @see #setUpdatedPreferencesVariable(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_UpdatedPreferencesVariable()
	 * @model 
	 * @generated
	 */
	String getUpdatedPreferencesVariable();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getUpdatedPreferencesVariable <em>Updated Preferences Variable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Updated Preferences Variable</em>' attribute.
	 * @see #getUpdatedPreferencesVariable()
	 * @generated
	 */
	void setUpdatedPreferencesVariable(String value);

	/**
	 * Returns the value of the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Url</em>' attribute.
	 * @see #setUrl(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_Url()
	 * @model required="true"
	 * @generated
	 */
	String getUrl();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getUrl <em>Url</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Url</em>' attribute.
	 * @see #getUrl()
	 * @generated
	 */
	void setUrl(String value);

	/**
	 * Returns the value of the '<em><b>Tooltip</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tooltip</em>' containment reference.
	 * @see #setTooltip(Tooltip)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getPreferences_Tooltip()
	 * @model containment="true"
	 * @generated
	 */
	Tooltip getTooltip();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Preferences#getTooltip <em>Tooltip</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tooltip</em>' containment reference.
	 * @see #getTooltip()
	 * @generated
	 */
	void setTooltip(Tooltip value);

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // Preferences
