/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DCurveLink.java,v 1.2 2008-05-23 14:11:48 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 7 nov. 2003
 *
 */
package org.eclipse.tptp.platform.report.core.internal;

/**
 * This class provides a curve which can be an IDLink
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 */
public class DCurveLink extends DCurve implements IDLink
{
  private String target_;
  
  /**
   * Creates a link curve item with empty default link.
   */
  public DCurveLink()
  {
  }

  /**
   * Creates a link curve item with the link target.
   */
  public DCurveLink( String a_target )
  {
    target_ = a_target;
  }
  
  /**
   * @see IDLink#getTarget
   */
  public String getTarget()
  {
    return target_;
  }

  /**
   * @see IDLink#setTarget
   */
  public void setTarget( String a_target )
  {
    target_ = a_target;
  }

  /**
   * @see IDLink#getLinkedItem
   */
  public IDItem getLinkedItem()
  {
    return this;
  }
}
