/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DText.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/



package org.eclipse.tptp.platform.report.core.internal;


/**
 * DText defines a string to be displayed in a document.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DText extends DItem implements IDBasicItem, IDTextualItem
{
   private String text;
   
   /**
    * Creates a DText with the string 't'.
    */
   public DText(String t) 
   {
     text = t;    
   }
   
   /**
    * Creates a DText with a String equal to null.
    */
   public DText() 
   {}
   
   /**
    * Access method for the text property.
    * 
    * @return   the current value of the text property
    */
   public String getText() 
   {
    return text;    
   }
   
   /**
    * Sets the value of the text property.
    * 
    * @param aText the new value of the text property
    */
   public void setText(String aText) 
   {
      text = aText;    
   }
}
