/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IPoint.java,v 1.2 2008-05-23 14:11:51 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.igc.internal;

/**
 * Abstraction of a point in an XY integer coordinates
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IPoint
{
  /**@return X coordinate of point */
  public int getX();
  /**@return Y coordinate of point */
  public int getY();
  /**Change X coordinate of point */
  public void setX(int x);
  /**Change Y coordinate of point */
  public void setY(int y);
  /**Change both coordinates */
  public void setPoint( int x, int y );
  /**Change both coordinates */
  public void setPoint( IPoint point );
}
