/**********************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.trace.ui.internal.control.provider;

import java.util.ArrayList;
import java.util.Hashtable;

import org.eclipse.tptp.trace.ui.provisional.control.provider.IControlItem;

/** See ControlProviderManager for how this class is used. */
public class ControlItemSet {
	private ArrayList<String> _insertedOrder;
	private Hashtable<String, IControlItem> _controlItemsSet;
	
	
	public ControlItemSet(Hashtable<String, IControlItem> controlItemsSet, ArrayList<String> insertedOrder) {
		this._insertedOrder = insertedOrder;
		this._controlItemsSet = controlItemsSet;
	}


	public ArrayList<String> getInsertedOrder() {
		return _insertedOrder;
	}


	public Hashtable<String, IControlItem> getControlItemsSet() {
		return _controlItemsSet;
	}

	
	
	
}
