/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * $Id: 
 *******************************************************************************/ 

package org.eclipse.tptp.platform.execution.client.core.internal.commands;

import org.eclipse.tptp.platform.execution.util.internal.CommandElement;
import org.eclipse.tptp.platform.execution.util.internal.Constants;
import org.eclipse.tptp.platform.execution.util.internal.TPTPMessageUtil;
import org.eclipse.tptp.platform.execution.util.internal.TPTPString;

public class RemoveExternalIPFromAllowListCommand extends CommandElement {
	String ipAddress;
	
	public RemoveExternalIPFromAllowListCommand(String ipAddress) {
		this.ipAddress = ipAddress;
	}
	
	public String buildCommand() {
		return "<removeExternalIPFromAllowList iid=\"" + Constants.AGNT_MGR_IID + "\">" 
		+ "<externalIP>"+ipAddress+"</externalIP>" +
			"</removeExternalIPFromAllowList>";
	}
	
	public int getSize() {
		return 0;
	}

	public int readFromBuffer(byte[] buffer, int offset) {		
		return 0;
	}

	public int writeToBuffer(byte[] buffer, int offset) {

		int current=offset;
		current=TPTPMessageUtil.writeTPTPStringToBuffer(buffer, current, new TPTPString(this.buildCommand()));
		return current;		
	}

}
