/**********************************************************************
 * Copyright (c) 2003, 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TracePackageImpl.java,v 1.19 2010/12/08 18:45:46 jcayne Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */
package org.eclipse.hyades.models.trace.impl;

import java.util.Map;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.hyades.models.hierarchy.HierarchyPackage;
import org.eclipse.hyades.models.trace.TRCAggregatedMethodInvocation;
import org.eclipse.hyades.models.trace.TRCAggregatedObjectReference;
import org.eclipse.hyades.models.trace.TRCArrayClass;
import org.eclipse.hyades.models.trace.TRCCallerCalleeInvocationInfo;
import org.eclipse.hyades.models.trace.TRCClass;
import org.eclipse.hyades.models.trace.TRCClassLoader;
import org.eclipse.hyades.models.trace.TRCCollectionBoundary;
import org.eclipse.hyades.models.trace.TRCFullHeapObject;
import org.eclipse.hyades.models.trace.TRCFullMethodInvocation;
import org.eclipse.hyades.models.trace.TRCFullTraceObject;
import org.eclipse.hyades.models.trace.TRCGCEvent;
import org.eclipse.hyades.models.trace.TRCGCRootType;
import org.eclipse.hyades.models.trace.TRCHeapDump;
import org.eclipse.hyades.models.trace.TRCHeapObject;
import org.eclipse.hyades.models.trace.TRCHeapRoot;
import org.eclipse.hyades.models.trace.TRCInputOutputContainer;
import org.eclipse.hyades.models.trace.TRCLLData;
import org.eclipse.hyades.models.trace.TRCLanguageElement;
import org.eclipse.hyades.models.trace.TRCLineCoverageData;
import org.eclipse.hyades.models.trace.TRCLinePerformanceData;
import org.eclipse.hyades.models.trace.TRCLockAccess;
import org.eclipse.hyades.models.trace.TRCMemoryStatsManager;
import org.eclipse.hyades.models.trace.TRCMethod;
import org.eclipse.hyades.models.trace.TRCMethodInvocation;
import org.eclipse.hyades.models.trace.TRCMethodProperties;
import org.eclipse.hyades.models.trace.TRCMethodWithLLData;
import org.eclipse.hyades.models.trace.TRCObjAllocSite;
import org.eclipse.hyades.models.trace.TRCObject;
import org.eclipse.hyades.models.trace.TRCObjectAllocationAnnotation;
import org.eclipse.hyades.models.trace.TRCObjectReference;
import org.eclipse.hyades.models.trace.TRCObjectValue;
import org.eclipse.hyades.models.trace.TRCObjectValueKind;
import org.eclipse.hyades.models.trace.TRCObjectValuePosition;
import org.eclipse.hyades.models.trace.TRCPackage;
import org.eclipse.hyades.models.trace.TRCPrimitiveType;
import org.eclipse.hyades.models.trace.TRCProcess;
import org.eclipse.hyades.models.trace.TRCSignatureNotation;
import org.eclipse.hyades.models.trace.TRCSourceInfo;
import org.eclipse.hyades.models.trace.TRCSourceInfoWithLLData;
import org.eclipse.hyades.models.trace.TRCThread;
import org.eclipse.hyades.models.trace.TRCThreadDeadAndNotifyJoinedEvent;
import org.eclipse.hyades.models.trace.TRCThreadDeadEvent;
import org.eclipse.hyades.models.trace.TRCThreadDeadLockEvent;
import org.eclipse.hyades.models.trace.TRCThreadEvent;
import org.eclipse.hyades.models.trace.TRCThreadExecEvent;
import org.eclipse.hyades.models.trace.TRCThreadHandoffLockEvent;
import org.eclipse.hyades.models.trace.TRCThreadInterruptThreadEvent;
import org.eclipse.hyades.models.trace.TRCThreadNotifyAllEvent;
import org.eclipse.hyades.models.trace.TRCThreadNotifyEvent;
import org.eclipse.hyades.models.trace.TRCThreadRunningEvent;
import org.eclipse.hyades.models.trace.TRCThreadSleepingEvent;
import org.eclipse.hyades.models.trace.TRCThreadStartThreadEvent;
import org.eclipse.hyades.models.trace.TRCThreadWaitTimeoutExceedEvent;
import org.eclipse.hyades.models.trace.TRCThreadWaitingForJoinEvent;
import org.eclipse.hyades.models.trace.TRCThreadWaitingForLockEvent;
import org.eclipse.hyades.models.trace.TRCThreadWaitingForObjectEvent;
import org.eclipse.hyades.models.trace.TRCTraceObject;
import org.eclipse.hyades.models.trace.TRCTypedObjectValue;
import org.eclipse.hyades.models.trace.TraceFactory;
import org.eclipse.hyades.models.trace.TracePackage;
import org.eclipse.hyades.models.trace.util.LLUnitData;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TracePackageImpl extends EPackageImpl implements TracePackage {
/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcObjectEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcClassEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcMethodInvocationEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcProcessEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcMethodEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcPackageEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcCollectionBoundaryEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcClassLoaderEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcSourceInfoEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcHeapObjectEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcFullTraceObjectEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcTraceObjectEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcFullHeapObjectEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcMemoryStatsManagerEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcObjectReferenceEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcHeapDumpEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcAggregatedMethodInvocationEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcFullMethodInvocationEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcHeapRootEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcArrayClassEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcAggregatedObjectReferenceEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadSleepingEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadWaitingForObjectEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadWaitingForLockEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadRunningEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadDeadEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcMethodWithLLDataEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcllDataEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcSourceInfoWithLLDataEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcLineCoverageDataEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcObjectValueEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcInputOutputEntryEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcInputOutputContainerEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcCallerCalleeInvocationInfoEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcTypedObjectValueEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcMthdLckAccEntryEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcLockAccessEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcLinePerformanceDataEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadDeadLockEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcLanguageElementEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcgcEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcObjectAllocationAnnotationEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadWaitTimeoutExceedEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadWaitingForJoinEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadExecEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadNotifyAllEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadNotifyEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadDeadAndNotifyJoinedEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadStartThreadEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadInterruptThreadEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcThreadHandoffLockEventEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trcObjAllocSiteEClass = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcPrimitiveTypeEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcSignatureNotationEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcMethodPropertiesEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcgcRootTypeEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcObjectValueKindEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum trcObjectValuePositionEEnum = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType eObjectIDEDataType = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType eMethodIDEDataType = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType eClassIDEDataType = null;

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType llUnitDataEDataType = null;

/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.models.trace.TracePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private TracePackageImpl() {
		super(eNS_URI, TraceFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link TracePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static TracePackage init() {
		if (isInited) return (TracePackage)EPackage.Registry.INSTANCE.getEPackage(TracePackage.eNS_URI);

		// Obtain or create and register package
		TracePackageImpl theTracePackage = (TracePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof TracePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new TracePackageImpl());

		isInited = true;

		// Initialize simple dependencies
		HierarchyPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theTracePackage.createPackageContents();

		// Initialize created meta-data
		theTracePackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theTracePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(TracePackage.eNS_URI, theTracePackage);
		return theTracePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCObject() {
		return trcObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObject_Id() {
		return (EAttribute)trcObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObject_Size() {
		return (EAttribute)trcObjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObject_IsA() {
		return (EReference)trcObjectEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObject_Process() {
		return (EReference)trcObjectEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObject_CumulativeSize() {
		return (EAttribute)trcObjectEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCClass() {
		return trcClassEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_Id() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_Name() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_Size() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_LoadTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_UnloadTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_Interface() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_LineNo() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_LineCount() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_BaseTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_CumulativeTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_Calls() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_InheritedCalls() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_InheritedBaseTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_InheritedCumulativeTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_TotalSize() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_TotalInstances() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_CollectedSize() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_CollectedInstances() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_TotalCpuTime() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Objects() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_LoadedBy() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Methods() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_ClassObjects() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Package() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(23);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_ClassLoader() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(24);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_EnclosedBy() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(25);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Extends() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(26);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Implements() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(27);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_Locks() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(28);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_CumulativeSize() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(29);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClass_AllocationSites() {
		return (EReference)trcClassEClass.getEStructuralFeatures().get(30);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCClass_OrigFullName() {
		return (EAttribute)trcClassEClass.getEStructuralFeatures().get(31);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCMethodInvocation() {
		return trcMethodInvocationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_Method() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_InvokedBy() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_Invokes() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_Thread() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_Process() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodInvocation_OwningObject() {
		return (EReference)trcMethodInvocationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethodInvocation_MethodEnterTraceOrder() {
		return (EAttribute)trcMethodInvocationEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethodInvocation_MethodExitTraceOrder() {
		return (EAttribute)trcMethodInvocationEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCProcess() {
		return trcProcessEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Pid() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Name() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Id() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_StartTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_StopTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_LastEventTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_InitFinishedTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_BaseTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_CumulativeTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Calls() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_InheritedCalls() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_InheritedBaseTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_InheritedCumulativeTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_TotalSize() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_TotalInstances() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_CollectedSize() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_CollectedInstances() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_ReferencePointerSize() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_TotalCpuTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_CpuSampleResolution() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_AbsoluteTime() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_ThreadStates() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Precision() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCProcess_Languages() {
		return (EAttribute)trcProcessEClass.getEStructuralFeatures().get(23);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_Threads() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(24);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_Packages() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(25);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_ClassClass() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(26);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_CollectionBoundaryPoints() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(27);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_ClassLoaders() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(28);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_SourceInfos() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(29);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_Objects() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(30);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_HeapDumps() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(31);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_Invocations() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(32);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_InputOutputContainer() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(33);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_MethodLockAccessEntries() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(34);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_Annotations() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(35);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_GcEvents() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(36);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCProcess_ProcessMemStats() {
		return (EReference)trcProcessEClass.getEStructuralFeatures().get(37);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThread() {
		return trcThreadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_Id() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_Name() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_GroupName() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_StartTime() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_StopTime() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_MaxStackDepth() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThread_TotalCpuTime() {
		return (EAttribute)trcThreadEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThread_Process() {
		return (EReference)trcThreadEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThread_InitialInvocations() {
		return (EReference)trcThreadEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThread_ThreadObject() {
		return (EReference)trcThreadEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThread_ThreadEvents() {
		return (EReference)trcThreadEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThread_Annotations() {
		return (EReference)trcThreadEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCMethod() {
		return trcMethodEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Id() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Name() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Signature() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Modifier() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_OrigSignature() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_OrigName() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Notation() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_LineNo() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_LineCount() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_BaseTime() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_CumulativeTime() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_Calls() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMethod_TotalCpuTime() {
		return (EAttribute)trcMethodEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethod_DefiningClass() {
		return (EReference)trcMethodEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethod_Invocations() {
		return (EReference)trcMethodEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCPackage() {
		return trcPackageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_Name() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_BaseTime() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_CumulativeTime() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_Calls() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_InheritedCalls() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_InheritedBaseTime() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_InheritedCumulativeTime() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_TotalSize() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_TotalInstances() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_CollectedSize() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_CollectedInstances() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCPackage_TotalCpuTime() {
		return (EAttribute)trcPackageEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCPackage_Process() {
		return (EReference)trcPackageEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCPackage_Classes() {
		return (EReference)trcPackageEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCPackage_SubPackages() {
		return (EReference)trcPackageEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCPackage_Parent() {
		return (EReference)trcPackageEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCCollectionBoundary() {
		return trcCollectionBoundaryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastInvocation() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_Process() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastClass() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastThread() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastObject() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastPackage() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_LastMethod() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCCollectionBoundary_HeapDump() {
		return (EReference)trcCollectionBoundaryEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCClassLoader() {
		return trcClassLoaderEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClassLoader_Process() {
		return (EReference)trcClassLoaderEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCClassLoader_ClassLoaderInstance() {
		return (EReference)trcClassLoaderEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCSourceInfo() {
		return trcSourceInfoEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCSourceInfo_Location() {
		return (EAttribute)trcSourceInfoEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCSourceInfo_Language() {
		return (EAttribute)trcSourceInfoEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCHeapObject() {
		return trcHeapObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapObject_RefOwner() {
		return (EReference)trcHeapObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapObject_RefTarget() {
		return (EReference)trcHeapObjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCFullTraceObject() {
		return trcFullTraceObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullTraceObject_CreateTime() {
		return (EAttribute)trcFullTraceObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullTraceObject_CollectTime() {
		return (EAttribute)trcFullTraceObjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullTraceObject_BaseTime() {
		return (EAttribute)trcFullTraceObjectEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullTraceObject_CumulativeTime() {
		return (EAttribute)trcFullTraceObjectEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullTraceObject_Calls() {
		return (EAttribute)trcFullTraceObjectEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCFullTraceObject_ObjAllocSite() {
		return (EReference)trcFullTraceObjectEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCTraceObject() {
		return trcTraceObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCTraceObject_Invocations() {
		return (EReference)trcTraceObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCTraceObject_Thread() {
		return (EReference)trcTraceObjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCFullHeapObject() {
		return trcFullHeapObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullHeapObject_HeapDumpFirstSeen() {
		return (EAttribute)trcFullHeapObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCMemoryStatsManager() {
		return trcMemoryStatsManagerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMemoryStatsManager_NumFullMethInvocObjs() {
		return (EAttribute)trcMemoryStatsManagerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMemoryStatsManager_NumAggMethInvocObjs() {
		return (EAttribute)trcMemoryStatsManagerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCMemoryStatsManager_NumHeapObjs() {
		return (EAttribute)trcMemoryStatsManagerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCObjectReference() {
		return trcObjectReferenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectReference_HeapDump() {
		return (EReference)trcObjectReferenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectReference_Owner() {
		return (EReference)trcObjectReferenceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectReference_Target() {
		return (EReference)trcObjectReferenceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCHeapDump() {
		return trcHeapDumpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapDump_Id() {
		return (EAttribute)trcHeapDumpEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapDump_EntryTime() {
		return (EAttribute)trcHeapDumpEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapDump_ExitTime() {
		return (EAttribute)trcHeapDumpEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapDump_Name() {
		return (EAttribute)trcHeapDumpEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapDump_References() {
		return (EReference)trcHeapDumpEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapDump_Process() {
		return (EReference)trcHeapDumpEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapDump_GcRoots() {
		return (EReference)trcHeapDumpEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCAggregatedMethodInvocation() {
		return trcAggregatedMethodInvocationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_Count() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_BaseTime() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_CumulativeTime() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_MinTime() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_MaxTime() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_CallerLineNo() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedMethodInvocation_TotalCpuTime() {
		return (EAttribute)trcAggregatedMethodInvocationEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCFullMethodInvocation() {
		return trcFullMethodInvocationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_StackDepth() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_EntryTime() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_ExitTime() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_Ticket() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_Overhead() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_CallerLineNo() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_CpuTime() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_OrigEntryTime() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCFullMethodInvocation_OrigExitTime() {
		return (EAttribute)trcFullMethodInvocationEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCHeapRoot() {
		return trcHeapRootEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapRoot_Type() {
		return (EAttribute)trcHeapRootEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCHeapRoot_Frame() {
		return (EAttribute)trcHeapRootEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapRoot_HeapDump() {
		return (EReference)trcHeapRootEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapRoot_Thread() {
		return (EReference)trcHeapRootEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCHeapRoot_Object() {
		return (EReference)trcHeapRootEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCArrayClass() {
		return trcArrayClassEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCArrayClass_ArrayType() {
		return (EAttribute)trcArrayClassEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCArrayClass_ElementType() {
		return (EReference)trcArrayClassEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCAggregatedObjectReference() {
		return trcAggregatedObjectReferenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedObjectReference_OwnerSize() {
		return (EAttribute)trcAggregatedObjectReferenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedObjectReference_TargetSize() {
		return (EAttribute)trcAggregatedObjectReferenceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCAggregatedObjectReference_Count() {
		return (EAttribute)trcAggregatedObjectReferenceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadEvent() {
		return trcThreadEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThreadEvent_Time() {
		return (EAttribute)trcThreadEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThreadEvent_TraceOrder() {
		return (EAttribute)trcThreadEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadEvent_Thread() {
		return (EReference)trcThreadEventEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadEvent_Annotations() {
		return (EReference)trcThreadEventEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadSleepingEvent() {
		return trcThreadSleepingEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThreadSleepingEvent_SleepingTime() {
		return (EAttribute)trcThreadSleepingEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadWaitingForObjectEvent() {
		return trcThreadWaitingForObjectEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThreadWaitingForObjectEvent_Timeout() {
		return (EAttribute)trcThreadWaitingForObjectEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadWaitingForObjectEvent_ObjectWaitingFor() {
		return (EReference)trcThreadWaitingForObjectEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadWaitingForLockEvent() {
		return trcThreadWaitingForLockEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadWaitingForLockEvent_LockedObject() {
		return (EReference)trcThreadWaitingForLockEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadWaitingForLockEvent_LockingThread() {
		return (EReference)trcThreadWaitingForLockEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadRunningEvent() {
		return trcThreadRunningEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadDeadEvent() {
		return trcThreadDeadEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCMethodWithLLData() {
		return trcMethodWithLLDataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMethodWithLLData_LLData() {
		return (EReference)trcMethodWithLLDataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCLLData() {
		return trcllDataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLLData_SummaryUnits() {
		return (EAttribute)trcllDataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLLData_SummaryNonzero() {
		return (EAttribute)trcllDataEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLLData_TypeId() {
		return (EAttribute)trcllDataEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLLData_Headings() {
		return (EAttribute)trcllDataEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCLLData_Method() {
		return (EReference)trcllDataEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCSourceInfoWithLLData() {
		return trcSourceInfoWithLLDataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCSourceInfoWithLLData_LLDatas() {
		return (EReference)trcSourceInfoWithLLDataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCLineCoverageData() {
		return trcLineCoverageDataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLineCoverageData_LineTable() {
		return (EAttribute)trcLineCoverageDataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLineCoverageData_HitTable() {
		return (EAttribute)trcLineCoverageDataEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLineCoverageData_CountTable() {
		return (EAttribute)trcLineCoverageDataEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCLineCoverageData_SourceInfo() {
		return (EReference)trcLineCoverageDataEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCObjectValue() {
		return trcObjectValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObjectValue_StringValue() {
		return (EAttribute)trcObjectValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectValue_TRCInputOutputEntry() {
		return (EReference)trcObjectValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectValue_Container() {
		return (EReference)trcObjectValueEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCInputOutputEntry() {
		return trcInputOutputEntryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputEntry_Value() {
		return (EReference)trcInputOutputEntryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputEntry_Container() {
		return (EReference)trcInputOutputEntryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputEntry_Key() {
		return (EReference)trcInputOutputEntryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCInputOutputContainer() {
		return trcInputOutputContainerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputContainer_Process() {
		return (EReference)trcInputOutputContainerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputContainer_Entries() {
		return (EReference)trcInputOutputContainerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCInputOutputContainer_InputOutputValues() {
		return (EReference)trcInputOutputContainerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCCallerCalleeInvocationInfo() {
		return trcCallerCalleeInvocationInfoEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCCallerCalleeInvocationInfo_CallTime() {
		return (EAttribute)trcCallerCalleeInvocationInfoEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCCallerCalleeInvocationInfo_ReturnTime() {
		return (EAttribute)trcCallerCalleeInvocationInfoEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCCallerCalleeInvocationInfo_CallOverhead() {
		return (EAttribute)trcCallerCalleeInvocationInfoEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCTypedObjectValue() {
		return trcTypedObjectValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCTypedObjectValue_ValueKind() {
		return (EAttribute)trcTypedObjectValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCTypedObjectValue_PositionKind() {
		return (EAttribute)trcTypedObjectValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCTypedObjectValue_Position() {
		return (EAttribute)trcTypedObjectValueEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCTypedObjectValue_Object() {
		return (EReference)trcTypedObjectValueEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCMthdLckAccEntry() {
		return trcMthdLckAccEntryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMthdLckAccEntry_Process() {
		return (EReference)trcMthdLckAccEntryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMthdLckAccEntry_Value() {
		return (EReference)trcMthdLckAccEntryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCMthdLckAccEntry_Key() {
		return (EReference)trcMthdLckAccEntryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCLockAccess() {
		return trcLockAccessEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLockAccess_RequireTime() {
		return (EAttribute)trcLockAccessEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLockAccess_RequestTime() {
		return (EAttribute)trcLockAccessEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLockAccess_ReleaseTime() {
		return (EAttribute)trcLockAccessEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLockAccess_AtLine() {
		return (EAttribute)trcLockAccessEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCLockAccess_OnObject() {
		return (EReference)trcLockAccessEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCLinePerformanceData() {
		return trcLinePerformanceDataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCLinePerformanceData_AccumulatedTimeTable() {
		return (EAttribute)trcLinePerformanceDataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadDeadLockEvent() {
		return trcThreadDeadLockEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadDeadLockEvent_NextDeadLockEvent() {
		return (EReference)trcThreadDeadLockEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCLanguageElement() {
		return trcLanguageElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCLanguageElement_SourceInfo() {
		return (EReference)trcLanguageElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCLanguageElement_Annotations() {
		return (EReference)trcLanguageElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCGCEvent() {
		return trcgcEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCGCEvent_Time() {
		return (EAttribute)trcgcEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCGCEvent_TotalObjectSpace() {
		return (EAttribute)trcgcEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCGCEvent_UsedObjectSpace() {
		return (EAttribute)trcgcEventEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCGCEvent_UsedObjects() {
		return (EAttribute)trcgcEventEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCGCEvent_Type() {
		return (EAttribute)trcgcEventEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCGCEvent_OwnerThread() {
		return (EReference)trcgcEventEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCObjectAllocationAnnotation() {
		return trcObjectAllocationAnnotationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectAllocationAnnotation_Methods() {
		return (EReference)trcObjectAllocationAnnotationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjectAllocationAnnotation_Classes() {
		return (EReference)trcObjectAllocationAnnotationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObjectAllocationAnnotation_LineNumbers() {
		return (EAttribute)trcObjectAllocationAnnotationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObjectAllocationAnnotation_CreateTimes() {
		return (EAttribute)trcObjectAllocationAnnotationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadWaitTimeoutExceedEvent() {
		return trcThreadWaitTimeoutExceedEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadWaitingForJoinEvent() {
		return trcThreadWaitingForJoinEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadExecEvent() {
		return trcThreadExecEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadExecEvent_RunningEvents() {
		return (EReference)trcThreadExecEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCThreadExecEvent_InCriticalPath() {
		return (EAttribute)trcThreadExecEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadNotifyAllEvent() {
		return trcThreadNotifyAllEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadNotifyEvent() {
		return trcThreadNotifyEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadDeadAndNotifyJoinedEvent() {
		return trcThreadDeadAndNotifyJoinedEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadStartThreadEvent() {
		return trcThreadStartThreadEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadStartThreadEvent_StartedThread() {
		return (EReference)trcThreadStartThreadEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadInterruptThreadEvent() {
		return trcThreadInterruptThreadEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadInterruptThreadEvent_InterruptedThread() {
		return (EReference)trcThreadInterruptThreadEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCThreadHandoffLockEvent() {
		return trcThreadHandoffLockEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCThreadHandoffLockEvent_LockedObject() {
		return (EReference)trcThreadHandoffLockEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObjAllocSite_LineNumber() {
		return (EAttribute)trcObjAllocSiteEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTRCObjAllocSite_ObjectsCreated() {
		return (EAttribute)trcObjAllocSiteEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTRCObjAllocSite() {
		return trcObjAllocSiteEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjAllocSite_Method() {
		return (EReference)trcObjAllocSiteEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTRCObjAllocSite_Class() {
		return (EReference)trcObjAllocSiteEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCPrimitiveType() {
		return trcPrimitiveTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCSignatureNotation() {
		return trcSignatureNotationEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCMethodProperties() {
		return trcMethodPropertiesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCGCRootType() {
		return trcgcRootTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCObjectValueKind() {
		return trcObjectValueKindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTRCObjectValuePosition() {
		return trcObjectValuePositionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getEObjectID() {
		return eObjectIDEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getEMethodID() {
		return eMethodIDEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getEClassID() {
		return eClassIDEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getLLUnitData() {
		return llUnitDataEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceFactory getTraceFactory() {
		return (TraceFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		trcgcEventEClass = createEClass(TRCGC_EVENT);
		createEAttribute(trcgcEventEClass, TRCGC_EVENT__TIME);
		createEAttribute(trcgcEventEClass, TRCGC_EVENT__TOTAL_OBJECT_SPACE);
		createEAttribute(trcgcEventEClass, TRCGC_EVENT__USED_OBJECT_SPACE);
		createEAttribute(trcgcEventEClass, TRCGC_EVENT__USED_OBJECTS);
		createEAttribute(trcgcEventEClass, TRCGC_EVENT__TYPE);
		createEReference(trcgcEventEClass, TRCGC_EVENT__OWNER_THREAD);

		trcObjectEClass = createEClass(TRC_OBJECT);
		createEAttribute(trcObjectEClass, TRC_OBJECT__ID);
		createEAttribute(trcObjectEClass, TRC_OBJECT__SIZE);
		createEReference(trcObjectEClass, TRC_OBJECT__IS_A);
		createEReference(trcObjectEClass, TRC_OBJECT__PROCESS);
		createEAttribute(trcObjectEClass, TRC_OBJECT__CUMULATIVE_SIZE);

		trcClassEClass = createEClass(TRC_CLASS);
		createEAttribute(trcClassEClass, TRC_CLASS__ID);
		createEAttribute(trcClassEClass, TRC_CLASS__NAME);
		createEAttribute(trcClassEClass, TRC_CLASS__SIZE);
		createEAttribute(trcClassEClass, TRC_CLASS__LOAD_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__UNLOAD_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__INTERFACE);
		createEAttribute(trcClassEClass, TRC_CLASS__LINE_NO);
		createEAttribute(trcClassEClass, TRC_CLASS__LINE_COUNT);
		createEAttribute(trcClassEClass, TRC_CLASS__BASE_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__CUMULATIVE_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__CALLS);
		createEAttribute(trcClassEClass, TRC_CLASS__INHERITED_CALLS);
		createEAttribute(trcClassEClass, TRC_CLASS__INHERITED_BASE_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__INHERITED_CUMULATIVE_TIME);
		createEAttribute(trcClassEClass, TRC_CLASS__TOTAL_SIZE);
		createEAttribute(trcClassEClass, TRC_CLASS__TOTAL_INSTANCES);
		createEAttribute(trcClassEClass, TRC_CLASS__COLLECTED_SIZE);
		createEAttribute(trcClassEClass, TRC_CLASS__COLLECTED_INSTANCES);
		createEAttribute(trcClassEClass, TRC_CLASS__TOTAL_CPU_TIME);
		createEReference(trcClassEClass, TRC_CLASS__OBJECTS);
		createEReference(trcClassEClass, TRC_CLASS__LOADED_BY);
		createEReference(trcClassEClass, TRC_CLASS__METHODS);
		createEReference(trcClassEClass, TRC_CLASS__CLASS_OBJECTS);
		createEReference(trcClassEClass, TRC_CLASS__PACKAGE);
		createEReference(trcClassEClass, TRC_CLASS__CLASS_LOADER);
		createEReference(trcClassEClass, TRC_CLASS__ENCLOSED_BY);
		createEReference(trcClassEClass, TRC_CLASS__EXTENDS);
		createEReference(trcClassEClass, TRC_CLASS__IMPLEMENTS);
		createEReference(trcClassEClass, TRC_CLASS__LOCKS);
		createEAttribute(trcClassEClass, TRC_CLASS__CUMULATIVE_SIZE);
		createEReference(trcClassEClass, TRC_CLASS__ALLOCATION_SITES);
		createEAttribute(trcClassEClass, TRC_CLASS__ORIG_FULL_NAME);

		trcMethodInvocationEClass = createEClass(TRC_METHOD_INVOCATION);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__METHOD);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__INVOKED_BY);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__INVOKES);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__THREAD);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__PROCESS);
		createEReference(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__OWNING_OBJECT);
		createEAttribute(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__METHOD_ENTER_TRACE_ORDER);
		createEAttribute(trcMethodInvocationEClass, TRC_METHOD_INVOCATION__METHOD_EXIT_TRACE_ORDER);

		trcProcessEClass = createEClass(TRC_PROCESS);
		createEAttribute(trcProcessEClass, TRC_PROCESS__PID);
		createEAttribute(trcProcessEClass, TRC_PROCESS__NAME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__ID);
		createEAttribute(trcProcessEClass, TRC_PROCESS__START_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__STOP_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__LAST_EVENT_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__INIT_FINISHED_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__BASE_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__CUMULATIVE_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__CALLS);
		createEAttribute(trcProcessEClass, TRC_PROCESS__INHERITED_CALLS);
		createEAttribute(trcProcessEClass, TRC_PROCESS__INHERITED_BASE_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__INHERITED_CUMULATIVE_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__TOTAL_SIZE);
		createEAttribute(trcProcessEClass, TRC_PROCESS__TOTAL_INSTANCES);
		createEAttribute(trcProcessEClass, TRC_PROCESS__COLLECTED_SIZE);
		createEAttribute(trcProcessEClass, TRC_PROCESS__COLLECTED_INSTANCES);
		createEAttribute(trcProcessEClass, TRC_PROCESS__REFERENCE_POINTER_SIZE);
		createEAttribute(trcProcessEClass, TRC_PROCESS__TOTAL_CPU_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__CPU_SAMPLE_RESOLUTION);
		createEAttribute(trcProcessEClass, TRC_PROCESS__ABSOLUTE_TIME);
		createEAttribute(trcProcessEClass, TRC_PROCESS__THREAD_STATES);
		createEAttribute(trcProcessEClass, TRC_PROCESS__PRECISION);
		createEAttribute(trcProcessEClass, TRC_PROCESS__LANGUAGES);
		createEReference(trcProcessEClass, TRC_PROCESS__THREADS);
		createEReference(trcProcessEClass, TRC_PROCESS__PACKAGES);
		createEReference(trcProcessEClass, TRC_PROCESS__CLASS_CLASS);
		createEReference(trcProcessEClass, TRC_PROCESS__COLLECTION_BOUNDARY_POINTS);
		createEReference(trcProcessEClass, TRC_PROCESS__CLASS_LOADERS);
		createEReference(trcProcessEClass, TRC_PROCESS__SOURCE_INFOS);
		createEReference(trcProcessEClass, TRC_PROCESS__OBJECTS);
		createEReference(trcProcessEClass, TRC_PROCESS__HEAP_DUMPS);
		createEReference(trcProcessEClass, TRC_PROCESS__INVOCATIONS);
		createEReference(trcProcessEClass, TRC_PROCESS__INPUT_OUTPUT_CONTAINER);
		createEReference(trcProcessEClass, TRC_PROCESS__METHOD_LOCK_ACCESS_ENTRIES);
		createEReference(trcProcessEClass, TRC_PROCESS__ANNOTATIONS);
		createEReference(trcProcessEClass, TRC_PROCESS__GC_EVENTS);
		createEReference(trcProcessEClass, TRC_PROCESS__PROCESS_MEM_STATS);

		trcThreadEClass = createEClass(TRC_THREAD);
		createEAttribute(trcThreadEClass, TRC_THREAD__ID);
		createEAttribute(trcThreadEClass, TRC_THREAD__NAME);
		createEAttribute(trcThreadEClass, TRC_THREAD__GROUP_NAME);
		createEAttribute(trcThreadEClass, TRC_THREAD__START_TIME);
		createEAttribute(trcThreadEClass, TRC_THREAD__STOP_TIME);
		createEAttribute(trcThreadEClass, TRC_THREAD__MAX_STACK_DEPTH);
		createEAttribute(trcThreadEClass, TRC_THREAD__TOTAL_CPU_TIME);
		createEReference(trcThreadEClass, TRC_THREAD__PROCESS);
		createEReference(trcThreadEClass, TRC_THREAD__INITIAL_INVOCATIONS);
		createEReference(trcThreadEClass, TRC_THREAD__THREAD_OBJECT);
		createEReference(trcThreadEClass, TRC_THREAD__THREAD_EVENTS);
		createEReference(trcThreadEClass, TRC_THREAD__ANNOTATIONS);

		trcMethodEClass = createEClass(TRC_METHOD);
		createEAttribute(trcMethodEClass, TRC_METHOD__ID);
		createEAttribute(trcMethodEClass, TRC_METHOD__NAME);
		createEAttribute(trcMethodEClass, TRC_METHOD__SIGNATURE);
		createEAttribute(trcMethodEClass, TRC_METHOD__MODIFIER);
		createEAttribute(trcMethodEClass, TRC_METHOD__ORIG_SIGNATURE);
		createEAttribute(trcMethodEClass, TRC_METHOD__ORIG_NAME);
		createEAttribute(trcMethodEClass, TRC_METHOD__NOTATION);
		createEAttribute(trcMethodEClass, TRC_METHOD__LINE_NO);
		createEAttribute(trcMethodEClass, TRC_METHOD__LINE_COUNT);
		createEAttribute(trcMethodEClass, TRC_METHOD__BASE_TIME);
		createEAttribute(trcMethodEClass, TRC_METHOD__CUMULATIVE_TIME);
		createEAttribute(trcMethodEClass, TRC_METHOD__CALLS);
		createEAttribute(trcMethodEClass, TRC_METHOD__TOTAL_CPU_TIME);
		createEReference(trcMethodEClass, TRC_METHOD__DEFINING_CLASS);
		createEReference(trcMethodEClass, TRC_METHOD__INVOCATIONS);

		trcPackageEClass = createEClass(TRC_PACKAGE);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__NAME);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__BASE_TIME);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__CUMULATIVE_TIME);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__CALLS);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__INHERITED_CALLS);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__INHERITED_BASE_TIME);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__INHERITED_CUMULATIVE_TIME);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__TOTAL_SIZE);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__TOTAL_INSTANCES);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__COLLECTED_SIZE);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__COLLECTED_INSTANCES);
		createEAttribute(trcPackageEClass, TRC_PACKAGE__TOTAL_CPU_TIME);
		createEReference(trcPackageEClass, TRC_PACKAGE__PROCESS);
		createEReference(trcPackageEClass, TRC_PACKAGE__CLASSES);
		createEReference(trcPackageEClass, TRC_PACKAGE__SUB_PACKAGES);
		createEReference(trcPackageEClass, TRC_PACKAGE__PARENT);

		trcCollectionBoundaryEClass = createEClass(TRC_COLLECTION_BOUNDARY);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_INVOCATION);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__PROCESS);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_CLASS);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_THREAD);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_OBJECT);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_PACKAGE);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__LAST_METHOD);
		createEReference(trcCollectionBoundaryEClass, TRC_COLLECTION_BOUNDARY__HEAP_DUMP);

		trcClassLoaderEClass = createEClass(TRC_CLASS_LOADER);
		createEReference(trcClassLoaderEClass, TRC_CLASS_LOADER__PROCESS);
		createEReference(trcClassLoaderEClass, TRC_CLASS_LOADER__CLASS_LOADER_INSTANCE);

		trcSourceInfoEClass = createEClass(TRC_SOURCE_INFO);
		createEAttribute(trcSourceInfoEClass, TRC_SOURCE_INFO__LOCATION);
		createEAttribute(trcSourceInfoEClass, TRC_SOURCE_INFO__LANGUAGE);

		trcHeapObjectEClass = createEClass(TRC_HEAP_OBJECT);
		createEReference(trcHeapObjectEClass, TRC_HEAP_OBJECT__REF_OWNER);
		createEReference(trcHeapObjectEClass, TRC_HEAP_OBJECT__REF_TARGET);

		trcFullTraceObjectEClass = createEClass(TRC_FULL_TRACE_OBJECT);
		createEAttribute(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__CREATE_TIME);
		createEAttribute(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__COLLECT_TIME);
		createEAttribute(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__BASE_TIME);
		createEAttribute(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__CUMULATIVE_TIME);
		createEAttribute(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__CALLS);
		createEReference(trcFullTraceObjectEClass, TRC_FULL_TRACE_OBJECT__OBJ_ALLOC_SITE);

		trcTraceObjectEClass = createEClass(TRC_TRACE_OBJECT);
		createEReference(trcTraceObjectEClass, TRC_TRACE_OBJECT__INVOCATIONS);
		createEReference(trcTraceObjectEClass, TRC_TRACE_OBJECT__THREAD);

		trcFullHeapObjectEClass = createEClass(TRC_FULL_HEAP_OBJECT);
		createEAttribute(trcFullHeapObjectEClass, TRC_FULL_HEAP_OBJECT__HEAP_DUMP_FIRST_SEEN);

		trcMemoryStatsManagerEClass = createEClass(TRC_MEMORY_STATS_MANAGER);
		createEAttribute(trcMemoryStatsManagerEClass, TRC_MEMORY_STATS_MANAGER__NUM_FULL_METH_INVOC_OBJS);
		createEAttribute(trcMemoryStatsManagerEClass, TRC_MEMORY_STATS_MANAGER__NUM_AGG_METH_INVOC_OBJS);
		createEAttribute(trcMemoryStatsManagerEClass, TRC_MEMORY_STATS_MANAGER__NUM_HEAP_OBJS);

		trcObjectReferenceEClass = createEClass(TRC_OBJECT_REFERENCE);
		createEReference(trcObjectReferenceEClass, TRC_OBJECT_REFERENCE__HEAP_DUMP);
		createEReference(trcObjectReferenceEClass, TRC_OBJECT_REFERENCE__OWNER);
		createEReference(trcObjectReferenceEClass, TRC_OBJECT_REFERENCE__TARGET);

		trcHeapDumpEClass = createEClass(TRC_HEAP_DUMP);
		createEAttribute(trcHeapDumpEClass, TRC_HEAP_DUMP__ID);
		createEAttribute(trcHeapDumpEClass, TRC_HEAP_DUMP__ENTRY_TIME);
		createEAttribute(trcHeapDumpEClass, TRC_HEAP_DUMP__EXIT_TIME);
		createEAttribute(trcHeapDumpEClass, TRC_HEAP_DUMP__NAME);
		createEReference(trcHeapDumpEClass, TRC_HEAP_DUMP__REFERENCES);
		createEReference(trcHeapDumpEClass, TRC_HEAP_DUMP__PROCESS);
		createEReference(trcHeapDumpEClass, TRC_HEAP_DUMP__GC_ROOTS);

		trcAggregatedMethodInvocationEClass = createEClass(TRC_AGGREGATED_METHOD_INVOCATION);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__COUNT);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__BASE_TIME);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__CUMULATIVE_TIME);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__MIN_TIME);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__MAX_TIME);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__CALLER_LINE_NO);
		createEAttribute(trcAggregatedMethodInvocationEClass, TRC_AGGREGATED_METHOD_INVOCATION__TOTAL_CPU_TIME);

		trcFullMethodInvocationEClass = createEClass(TRC_FULL_METHOD_INVOCATION);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__STACK_DEPTH);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__ENTRY_TIME);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__EXIT_TIME);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__TICKET);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__OVERHEAD);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__CALLER_LINE_NO);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__CPU_TIME);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__ORIG_ENTRY_TIME);
		createEAttribute(trcFullMethodInvocationEClass, TRC_FULL_METHOD_INVOCATION__ORIG_EXIT_TIME);

		trcHeapRootEClass = createEClass(TRC_HEAP_ROOT);
		createEAttribute(trcHeapRootEClass, TRC_HEAP_ROOT__TYPE);
		createEAttribute(trcHeapRootEClass, TRC_HEAP_ROOT__FRAME);
		createEReference(trcHeapRootEClass, TRC_HEAP_ROOT__HEAP_DUMP);
		createEReference(trcHeapRootEClass, TRC_HEAP_ROOT__THREAD);
		createEReference(trcHeapRootEClass, TRC_HEAP_ROOT__OBJECT);

		trcArrayClassEClass = createEClass(TRC_ARRAY_CLASS);
		createEAttribute(trcArrayClassEClass, TRC_ARRAY_CLASS__ARRAY_TYPE);
		createEReference(trcArrayClassEClass, TRC_ARRAY_CLASS__ELEMENT_TYPE);

		trcAggregatedObjectReferenceEClass = createEClass(TRC_AGGREGATED_OBJECT_REFERENCE);
		createEAttribute(trcAggregatedObjectReferenceEClass, TRC_AGGREGATED_OBJECT_REFERENCE__OWNER_SIZE);
		createEAttribute(trcAggregatedObjectReferenceEClass, TRC_AGGREGATED_OBJECT_REFERENCE__TARGET_SIZE);
		createEAttribute(trcAggregatedObjectReferenceEClass, TRC_AGGREGATED_OBJECT_REFERENCE__COUNT);

		trcThreadEventEClass = createEClass(TRC_THREAD_EVENT);
		createEAttribute(trcThreadEventEClass, TRC_THREAD_EVENT__TIME);
		createEAttribute(trcThreadEventEClass, TRC_THREAD_EVENT__TRACE_ORDER);
		createEReference(trcThreadEventEClass, TRC_THREAD_EVENT__THREAD);
		createEReference(trcThreadEventEClass, TRC_THREAD_EVENT__ANNOTATIONS);

		trcThreadSleepingEventEClass = createEClass(TRC_THREAD_SLEEPING_EVENT);
		createEAttribute(trcThreadSleepingEventEClass, TRC_THREAD_SLEEPING_EVENT__SLEEPING_TIME);

		trcThreadWaitingForObjectEventEClass = createEClass(TRC_THREAD_WAITING_FOR_OBJECT_EVENT);
		createEAttribute(trcThreadWaitingForObjectEventEClass, TRC_THREAD_WAITING_FOR_OBJECT_EVENT__TIMEOUT);
		createEReference(trcThreadWaitingForObjectEventEClass, TRC_THREAD_WAITING_FOR_OBJECT_EVENT__OBJECT_WAITING_FOR);

		trcThreadWaitingForLockEventEClass = createEClass(TRC_THREAD_WAITING_FOR_LOCK_EVENT);
		createEReference(trcThreadWaitingForLockEventEClass, TRC_THREAD_WAITING_FOR_LOCK_EVENT__LOCKED_OBJECT);
		createEReference(trcThreadWaitingForLockEventEClass, TRC_THREAD_WAITING_FOR_LOCK_EVENT__LOCKING_THREAD);

		trcThreadRunningEventEClass = createEClass(TRC_THREAD_RUNNING_EVENT);

		trcThreadDeadEventEClass = createEClass(TRC_THREAD_DEAD_EVENT);

		trcMethodWithLLDataEClass = createEClass(TRC_METHOD_WITH_LL_DATA);
		createEReference(trcMethodWithLLDataEClass, TRC_METHOD_WITH_LL_DATA__LL_DATA);

		trcllDataEClass = createEClass(TRCLL_DATA);
		createEAttribute(trcllDataEClass, TRCLL_DATA__SUMMARY_UNITS);
		createEAttribute(trcllDataEClass, TRCLL_DATA__SUMMARY_NONZERO);
		createEAttribute(trcllDataEClass, TRCLL_DATA__TYPE_ID);
		createEAttribute(trcllDataEClass, TRCLL_DATA__HEADINGS);
		createEReference(trcllDataEClass, TRCLL_DATA__METHOD);

		trcSourceInfoWithLLDataEClass = createEClass(TRC_SOURCE_INFO_WITH_LL_DATA);
		createEReference(trcSourceInfoWithLLDataEClass, TRC_SOURCE_INFO_WITH_LL_DATA__LL_DATAS);

		trcLineCoverageDataEClass = createEClass(TRC_LINE_COVERAGE_DATA);
		createEAttribute(trcLineCoverageDataEClass, TRC_LINE_COVERAGE_DATA__LINE_TABLE);
		createEAttribute(trcLineCoverageDataEClass, TRC_LINE_COVERAGE_DATA__HIT_TABLE);
		createEAttribute(trcLineCoverageDataEClass, TRC_LINE_COVERAGE_DATA__COUNT_TABLE);
		createEReference(trcLineCoverageDataEClass, TRC_LINE_COVERAGE_DATA__SOURCE_INFO);

		trcObjectValueEClass = createEClass(TRC_OBJECT_VALUE);
		createEAttribute(trcObjectValueEClass, TRC_OBJECT_VALUE__STRING_VALUE);
		createEReference(trcObjectValueEClass, TRC_OBJECT_VALUE__TRC_INPUT_OUTPUT_ENTRY);
		createEReference(trcObjectValueEClass, TRC_OBJECT_VALUE__CONTAINER);

		trcInputOutputEntryEClass = createEClass(TRC_INPUT_OUTPUT_ENTRY);
		createEReference(trcInputOutputEntryEClass, TRC_INPUT_OUTPUT_ENTRY__VALUE);
		createEReference(trcInputOutputEntryEClass, TRC_INPUT_OUTPUT_ENTRY__CONTAINER);
		createEReference(trcInputOutputEntryEClass, TRC_INPUT_OUTPUT_ENTRY__KEY);

		trcInputOutputContainerEClass = createEClass(TRC_INPUT_OUTPUT_CONTAINER);
		createEReference(trcInputOutputContainerEClass, TRC_INPUT_OUTPUT_CONTAINER__PROCESS);
		createEReference(trcInputOutputContainerEClass, TRC_INPUT_OUTPUT_CONTAINER__ENTRIES);
		createEReference(trcInputOutputContainerEClass, TRC_INPUT_OUTPUT_CONTAINER__INPUT_OUTPUT_VALUES);

		trcCallerCalleeInvocationInfoEClass = createEClass(TRC_CALLER_CALLEE_INVOCATION_INFO);
		createEAttribute(trcCallerCalleeInvocationInfoEClass, TRC_CALLER_CALLEE_INVOCATION_INFO__CALL_TIME);
		createEAttribute(trcCallerCalleeInvocationInfoEClass, TRC_CALLER_CALLEE_INVOCATION_INFO__RETURN_TIME);
		createEAttribute(trcCallerCalleeInvocationInfoEClass, TRC_CALLER_CALLEE_INVOCATION_INFO__CALL_OVERHEAD);

		trcTypedObjectValueEClass = createEClass(TRC_TYPED_OBJECT_VALUE);
		createEAttribute(trcTypedObjectValueEClass, TRC_TYPED_OBJECT_VALUE__VALUE_KIND);
		createEAttribute(trcTypedObjectValueEClass, TRC_TYPED_OBJECT_VALUE__POSITION_KIND);
		createEAttribute(trcTypedObjectValueEClass, TRC_TYPED_OBJECT_VALUE__POSITION);
		createEReference(trcTypedObjectValueEClass, TRC_TYPED_OBJECT_VALUE__OBJECT);

		trcMthdLckAccEntryEClass = createEClass(TRC_MTHD_LCK_ACC_ENTRY);
		createEReference(trcMthdLckAccEntryEClass, TRC_MTHD_LCK_ACC_ENTRY__PROCESS);
		createEReference(trcMthdLckAccEntryEClass, TRC_MTHD_LCK_ACC_ENTRY__VALUE);
		createEReference(trcMthdLckAccEntryEClass, TRC_MTHD_LCK_ACC_ENTRY__KEY);

		trcLockAccessEClass = createEClass(TRC_LOCK_ACCESS);
		createEAttribute(trcLockAccessEClass, TRC_LOCK_ACCESS__REQUIRE_TIME);
		createEAttribute(trcLockAccessEClass, TRC_LOCK_ACCESS__REQUEST_TIME);
		createEAttribute(trcLockAccessEClass, TRC_LOCK_ACCESS__RELEASE_TIME);
		createEAttribute(trcLockAccessEClass, TRC_LOCK_ACCESS__AT_LINE);
		createEReference(trcLockAccessEClass, TRC_LOCK_ACCESS__ON_OBJECT);

		trcLinePerformanceDataEClass = createEClass(TRC_LINE_PERFORMANCE_DATA);
		createEAttribute(trcLinePerformanceDataEClass, TRC_LINE_PERFORMANCE_DATA__ACCUMULATED_TIME_TABLE);

		trcThreadDeadLockEventEClass = createEClass(TRC_THREAD_DEAD_LOCK_EVENT);
		createEReference(trcThreadDeadLockEventEClass, TRC_THREAD_DEAD_LOCK_EVENT__NEXT_DEAD_LOCK_EVENT);

		trcLanguageElementEClass = createEClass(TRC_LANGUAGE_ELEMENT);
		createEReference(trcLanguageElementEClass, TRC_LANGUAGE_ELEMENT__SOURCE_INFO);
		createEReference(trcLanguageElementEClass, TRC_LANGUAGE_ELEMENT__ANNOTATIONS);

		trcObjectAllocationAnnotationEClass = createEClass(TRC_OBJECT_ALLOCATION_ANNOTATION);
		createEReference(trcObjectAllocationAnnotationEClass, TRC_OBJECT_ALLOCATION_ANNOTATION__METHODS);
		createEReference(trcObjectAllocationAnnotationEClass, TRC_OBJECT_ALLOCATION_ANNOTATION__CLASSES);
		createEAttribute(trcObjectAllocationAnnotationEClass, TRC_OBJECT_ALLOCATION_ANNOTATION__LINE_NUMBERS);
		createEAttribute(trcObjectAllocationAnnotationEClass, TRC_OBJECT_ALLOCATION_ANNOTATION__CREATE_TIMES);

		trcThreadWaitTimeoutExceedEventEClass = createEClass(TRC_THREAD_WAIT_TIMEOUT_EXCEED_EVENT);

		trcThreadWaitingForJoinEventEClass = createEClass(TRC_THREAD_WAITING_FOR_JOIN_EVENT);

		trcThreadExecEventEClass = createEClass(TRC_THREAD_EXEC_EVENT);
		createEReference(trcThreadExecEventEClass, TRC_THREAD_EXEC_EVENT__RUNNING_EVENTS);
		createEAttribute(trcThreadExecEventEClass, TRC_THREAD_EXEC_EVENT__IN_CRITICAL_PATH);

		trcThreadNotifyAllEventEClass = createEClass(TRC_THREAD_NOTIFY_ALL_EVENT);

		trcThreadNotifyEventEClass = createEClass(TRC_THREAD_NOTIFY_EVENT);

		trcThreadDeadAndNotifyJoinedEventEClass = createEClass(TRC_THREAD_DEAD_AND_NOTIFY_JOINED_EVENT);

		trcThreadStartThreadEventEClass = createEClass(TRC_THREAD_START_THREAD_EVENT);
		createEReference(trcThreadStartThreadEventEClass, TRC_THREAD_START_THREAD_EVENT__STARTED_THREAD);

		trcThreadInterruptThreadEventEClass = createEClass(TRC_THREAD_INTERRUPT_THREAD_EVENT);
		createEReference(trcThreadInterruptThreadEventEClass, TRC_THREAD_INTERRUPT_THREAD_EVENT__INTERRUPTED_THREAD);

		trcThreadHandoffLockEventEClass = createEClass(TRC_THREAD_HANDOFF_LOCK_EVENT);
		createEReference(trcThreadHandoffLockEventEClass, TRC_THREAD_HANDOFF_LOCK_EVENT__LOCKED_OBJECT);

		trcObjAllocSiteEClass = createEClass(TRC_OBJ_ALLOC_SITE);
		createEReference(trcObjAllocSiteEClass, TRC_OBJ_ALLOC_SITE__METHOD);
		createEReference(trcObjAllocSiteEClass, TRC_OBJ_ALLOC_SITE__CLASS);
		createEAttribute(trcObjAllocSiteEClass, TRC_OBJ_ALLOC_SITE__LINE_NUMBER);
		createEAttribute(trcObjAllocSiteEClass, TRC_OBJ_ALLOC_SITE__OBJECTS_CREATED);

		// Create enums
		trcPrimitiveTypeEEnum = createEEnum(TRC_PRIMITIVE_TYPE);
		trcSignatureNotationEEnum = createEEnum(TRC_SIGNATURE_NOTATION);
		trcMethodPropertiesEEnum = createEEnum(TRC_METHOD_PROPERTIES);
		trcgcRootTypeEEnum = createEEnum(TRCGC_ROOT_TYPE);
		trcObjectValueKindEEnum = createEEnum(TRC_OBJECT_VALUE_KIND);
		trcObjectValuePositionEEnum = createEEnum(TRC_OBJECT_VALUE_POSITION);

		// Create data types
		eObjectIDEDataType = createEDataType(EOBJECT_ID);
		eMethodIDEDataType = createEDataType(EMETHOD_ID);
		eClassIDEDataType = createEDataType(ECLASS_ID);
		llUnitDataEDataType = createEDataType(LL_UNIT_DATA);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);
		HierarchyPackage theHierarchyPackage = (HierarchyPackage)EPackage.Registry.INSTANCE.getEPackage(HierarchyPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		trcClassEClass.getESuperTypes().add(this.getTRCLanguageElement());
		trcProcessEClass.getESuperTypes().add(theHierarchyPackage.getAbstractTRCProcess());
		trcMethodEClass.getESuperTypes().add(this.getTRCLanguageElement());
		trcPackageEClass.getESuperTypes().add(this.getTRCLanguageElement());
		trcCollectionBoundaryEClass.getESuperTypes().add(theHierarchyPackage.getAbstractTRCCollectionBoundary());
		trcHeapObjectEClass.getESuperTypes().add(this.getTRCObject());
		trcFullTraceObjectEClass.getESuperTypes().add(this.getTRCTraceObject());
		trcTraceObjectEClass.getESuperTypes().add(this.getTRCObject());
		trcFullHeapObjectEClass.getESuperTypes().add(this.getTRCHeapObject());
		trcAggregatedMethodInvocationEClass.getESuperTypes().add(this.getTRCMethodInvocation());
		trcFullMethodInvocationEClass.getESuperTypes().add(this.getTRCMethodInvocation());
		trcArrayClassEClass.getESuperTypes().add(this.getTRCClass());
		trcAggregatedObjectReferenceEClass.getESuperTypes().add(this.getTRCObjectReference());
		trcThreadSleepingEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadWaitingForObjectEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadWaitingForLockEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadRunningEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadDeadEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcMethodWithLLDataEClass.getESuperTypes().add(this.getTRCMethod());
		trcSourceInfoWithLLDataEClass.getESuperTypes().add(this.getTRCSourceInfo());
		trcLineCoverageDataEClass.getESuperTypes().add(this.getTRCLLData());
		trcCallerCalleeInvocationInfoEClass.getESuperTypes().add(this.getTRCFullMethodInvocation());
		trcTypedObjectValueEClass.getESuperTypes().add(this.getTRCObjectValue());
		trcLinePerformanceDataEClass.getESuperTypes().add(this.getTRCLineCoverageData());
		trcThreadDeadLockEventEClass.getESuperTypes().add(this.getTRCThreadWaitingForLockEvent());
		trcObjectAllocationAnnotationEClass.getESuperTypes().add(theHierarchyPackage.getTRCAnnotation());
		trcThreadWaitTimeoutExceedEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadWaitingForJoinEventEClass.getESuperTypes().add(this.getTRCThreadWaitingForObjectEvent());
		trcThreadExecEventEClass.getESuperTypes().add(this.getTRCThreadEvent());
		trcThreadNotifyAllEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());
		trcThreadNotifyEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());
		trcThreadDeadAndNotifyJoinedEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());
		trcThreadStartThreadEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());
		trcThreadInterruptThreadEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());
		trcThreadHandoffLockEventEClass.getESuperTypes().add(this.getTRCThreadExecEvent());

		// Initialize classes and features; add operations and parameters
		initEClass(trcgcEventEClass, TRCGCEvent.class, "TRCGCEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCGCEvent_Time(), ecorePackage.getEDouble(), "time", null, 0, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCGCEvent_TotalObjectSpace(), ecorePackage.getELong(), "totalObjectSpace", null, 0, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCGCEvent_UsedObjectSpace(), ecorePackage.getELong(), "usedObjectSpace", null, 0, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCGCEvent_UsedObjects(), ecorePackage.getELong(), "usedObjects", null, 0, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCGCEvent_Type(), ecorePackage.getEString(), "type", null, 0, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCGCEvent_OwnerThread(), this.getTRCThread(), null, "ownerThread", null, 1, 1, TRCGCEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcObjectEClass, TRCObject.class, "TRCObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCObject_Id(), this.getEObjectID(), "id", null, 0, 1, TRCObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObject_Size(), ecorePackage.getEInt(), "size", null, 0, 1, TRCObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObject_IsA(), this.getTRCClass(), this.getTRCClass_Objects(), "isA", null, 1, 1, TRCObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObject_Process(), this.getTRCProcess(), this.getTRCProcess_Objects(), "process", null, 1, 1, TRCObject.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObject_CumulativeSize(), ecorePackage.getELong(), "cumulativeSize", null, 0, 1, TRCObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcClassEClass, TRCClass.class, "TRCClass", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCClass_Id(), this.getEClassID(), "id", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_Name(), ecorePackage.getEString(), "name", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_Size(), ecorePackage.getEInt(), "size", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_LoadTime(), ecorePackage.getEDouble(), "loadTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_UnloadTime(), ecorePackage.getEDouble(), "unloadTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_Interface(), ecorePackage.getEBoolean(), "interface", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_LineNo(), ecorePackage.getEInt(), "lineNo", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_LineCount(), ecorePackage.getEInt(), "lineCount", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_Calls(), ecorePackage.getEInt(), "calls", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_InheritedCalls(), ecorePackage.getEInt(), "inheritedCalls", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_InheritedBaseTime(), ecorePackage.getEDouble(), "inheritedBaseTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_InheritedCumulativeTime(), ecorePackage.getEDouble(), "inheritedCumulativeTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_TotalSize(), ecorePackage.getEInt(), "totalSize", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_TotalInstances(), ecorePackage.getEInt(), "totalInstances", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_CollectedSize(), ecorePackage.getEInt(), "collectedSize", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_CollectedInstances(), ecorePackage.getEInt(), "collectedInstances", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Objects(), this.getTRCObject(), this.getTRCObject_IsA(), "objects", null, 0, -1, TRCClass.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_LoadedBy(), this.getTRCThread(), null, "loadedBy", null, 1, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Methods(), this.getTRCMethod(), this.getTRCMethod_DefiningClass(), "methods", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_ClassObjects(), this.getTRCObject(), null, "classObjects", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Package(), this.getTRCPackage(), this.getTRCPackage_Classes(), "package", null, 1, 1, TRCClass.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_ClassLoader(), this.getTRCClassLoader(), null, "classLoader", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_EnclosedBy(), this.getTRCClass(), null, "enclosedBy", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Extends(), this.getTRCClass(), null, "extends", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Implements(), this.getTRCClass(), null, "implements", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_Locks(), this.getTRCLockAccess(), null, "locks", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_CumulativeSize(), ecorePackage.getELong(), "cumulativeSize", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClass_AllocationSites(), this.getTRCObjAllocSite(), this.getTRCObjAllocSite_Class(), "allocationSites", null, 0, -1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCClass_OrigFullName(), theEcorePackage.getEString(), "origFullName", null, 0, 1, TRCClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcMethodInvocationEClass, TRCMethodInvocation.class, "TRCMethodInvocation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCMethodInvocation_Method(), this.getTRCMethod(), this.getTRCMethod_Invocations(), "method", null, 1, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethodInvocation_InvokedBy(), this.getTRCMethodInvocation(), this.getTRCMethodInvocation_Invokes(), "invokedBy", null, 0, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethodInvocation_Invokes(), this.getTRCMethodInvocation(), this.getTRCMethodInvocation_InvokedBy(), "invokes", null, 0, -1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethodInvocation_Thread(), this.getTRCThread(), null, "thread", null, 1, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethodInvocation_Process(), this.getTRCProcess(), this.getTRCProcess_Invocations(), "process", null, 1, 1, TRCMethodInvocation.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethodInvocation_OwningObject(), this.getTRCTraceObject(), null, "owningObject", null, 0, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethodInvocation_MethodEnterTraceOrder(), theEcorePackage.getELong(), "methodEnterTraceOrder", "-1", 0, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethodInvocation_MethodExitTraceOrder(), theEcorePackage.getELong(), "methodExitTraceOrder", "-1", 0, 1, TRCMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcProcessEClass, TRCProcess.class, "TRCProcess", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCProcess_Pid(), ecorePackage.getEInt(), "pid", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_Name(), ecorePackage.getEString(), "name", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_Id(), ecorePackage.getEString(), "id", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_StartTime(), ecorePackage.getEDouble(), "startTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_StopTime(), ecorePackage.getEDouble(), "stopTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_LastEventTime(), ecorePackage.getEDouble(), "lastEventTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_InitFinishedTime(), ecorePackage.getEDouble(), "initFinishedTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_Calls(), ecorePackage.getEInt(), "calls", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_InheritedCalls(), ecorePackage.getEInt(), "inheritedCalls", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_InheritedBaseTime(), ecorePackage.getEDouble(), "inheritedBaseTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_InheritedCumulativeTime(), ecorePackage.getEDouble(), "inheritedCumulativeTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_TotalSize(), ecorePackage.getEInt(), "totalSize", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_TotalInstances(), ecorePackage.getEInt(), "totalInstances", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_CollectedSize(), ecorePackage.getEInt(), "collectedSize", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_CollectedInstances(), ecorePackage.getEInt(), "collectedInstances", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_ReferencePointerSize(), ecorePackage.getEShort(), "referencePointerSize", "4", 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_CpuSampleResolution(), ecorePackage.getEDouble(), "cpuSampleResolution", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_AbsoluteTime(), theEcorePackage.getEBigDecimal(), "absoluteTime", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_ThreadStates(), ecorePackage.getEString(), "threadStates", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_Precision(), ecorePackage.getELong(), "precision", "1", 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCProcess_Languages(), ecorePackage.getEString(), "languages", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_Threads(), this.getTRCThread(), this.getTRCThread_Process(), "threads", null, 1, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_Packages(), this.getTRCPackage(), this.getTRCPackage_Process(), "packages", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_ClassClass(), this.getTRCClass(), null, "classClass", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_CollectionBoundaryPoints(), this.getTRCCollectionBoundary(), this.getTRCCollectionBoundary_Process(), "collectionBoundaryPoints", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_ClassLoaders(), this.getTRCClassLoader(), this.getTRCClassLoader_Process(), "classLoaders", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_SourceInfos(), this.getTRCSourceInfo(), null, "sourceInfos", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_Objects(), this.getTRCObject(), this.getTRCObject_Process(), "objects", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_HeapDumps(), this.getTRCHeapDump(), this.getTRCHeapDump_Process(), "heapDumps", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_Invocations(), this.getTRCMethodInvocation(), this.getTRCMethodInvocation_Process(), "invocations", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_InputOutputContainer(), this.getTRCInputOutputContainer(), this.getTRCInputOutputContainer_Process(), "inputOutputContainer", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_MethodLockAccessEntries(), this.getTRCMthdLckAccEntry(), this.getTRCMthdLckAccEntry_Process(), "methodLockAccessEntries", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_Annotations(), theHierarchyPackage.getTRCAnnotation(), null, "annotations", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_GcEvents(), this.getTRCGCEvent(), null, "gcEvents", null, 0, -1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCProcess_ProcessMemStats(), this.getTRCMemoryStatsManager(), null, "processMemStats", null, 0, 1, TRCProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadEClass, TRCThread.class, "TRCThread", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCThread_Id(), ecorePackage.getEInt(), "id", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_Name(), ecorePackage.getEString(), "name", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_GroupName(), ecorePackage.getEString(), "groupName", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_StartTime(), ecorePackage.getEDouble(), "startTime", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_StopTime(), ecorePackage.getEDouble(), "stopTime", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_MaxStackDepth(), ecorePackage.getEInt(), "maxStackDepth", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThread_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThread_Process(), this.getTRCProcess(), this.getTRCProcess_Threads(), "process", null, 1, 1, TRCThread.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThread_InitialInvocations(), this.getTRCMethodInvocation(), null, "initialInvocations", null, 0, -1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThread_ThreadObject(), this.getTRCObject(), null, "threadObject", null, 0, 1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThread_ThreadEvents(), this.getTRCThreadEvent(), this.getTRCThreadEvent_Thread(), "threadEvents", null, 0, -1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThread_Annotations(), theHierarchyPackage.getTRCAnnotation(), null, "annotations", null, 0, -1, TRCThread.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcMethodEClass, TRCMethod.class, "TRCMethod", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCMethod_Id(), this.getEMethodID(), "id", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_Name(), ecorePackage.getEString(), "name", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_Signature(), ecorePackage.getEString(), "signature", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_Modifier(), ecorePackage.getEInt(), "modifier", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_OrigSignature(), theEcorePackage.getEString(), "origSignature", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_OrigName(), theEcorePackage.getEString(), "origName", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_Notation(), this.getTRCSignatureNotation(), "notation", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_LineNo(), ecorePackage.getEInt(), "lineNo", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_LineCount(), ecorePackage.getEInt(), "lineCount", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_Calls(), ecorePackage.getEInt(), "calls", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMethod_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCMethod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethod_DefiningClass(), this.getTRCClass(), this.getTRCClass_Methods(), "definingClass", null, 1, 1, TRCMethod.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMethod_Invocations(), this.getTRCMethodInvocation(), this.getTRCMethodInvocation_Method(), "invocations", null, 0, -1, TRCMethod.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcPackageEClass, TRCPackage.class, "TRCPackage", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCPackage_Name(), ecorePackage.getEString(), "name", "Default", 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_Calls(), ecorePackage.getEInt(), "calls", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_InheritedCalls(), ecorePackage.getEInt(), "inheritedCalls", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_InheritedBaseTime(), ecorePackage.getEDouble(), "inheritedBaseTime", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_InheritedCumulativeTime(), ecorePackage.getEDouble(), "inheritedCumulativeTime", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_TotalSize(), ecorePackage.getEInt(), "totalSize", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_TotalInstances(), ecorePackage.getEInt(), "totalInstances", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_CollectedSize(), ecorePackage.getEInt(), "collectedSize", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_CollectedInstances(), ecorePackage.getEInt(), "collectedInstances", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCPackage_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCPackage_Process(), this.getTRCProcess(), this.getTRCProcess_Packages(), "process", null, 1, 1, TRCPackage.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCPackage_Classes(), this.getTRCClass(), this.getTRCClass_Package(), "classes", null, 0, -1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCPackage_SubPackages(), this.getTRCPackage(), this.getTRCPackage_Parent(), "subPackages", null, 0, -1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCPackage_Parent(), this.getTRCPackage(), this.getTRCPackage_SubPackages(), "parent", null, 0, 1, TRCPackage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcCollectionBoundaryEClass, TRCCollectionBoundary.class, "TRCCollectionBoundary", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCCollectionBoundary_LastInvocation(), this.getTRCMethodInvocation(), null, "lastInvocation", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_Process(), this.getTRCProcess(), this.getTRCProcess_CollectionBoundaryPoints(), "process", null, 1, 1, TRCCollectionBoundary.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_LastClass(), this.getTRCClass(), null, "lastClass", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_LastThread(), this.getTRCThread(), null, "lastThread", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_LastObject(), this.getTRCObject(), null, "lastObject", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_LastPackage(), this.getTRCPackage(), null, "lastPackage", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_LastMethod(), this.getTRCMethod(), null, "lastMethod", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCCollectionBoundary_HeapDump(), this.getTRCHeapDump(), null, "heapDump", null, 0, 1, TRCCollectionBoundary.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcClassLoaderEClass, TRCClassLoader.class, "TRCClassLoader", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCClassLoader_Process(), this.getTRCProcess(), this.getTRCProcess_ClassLoaders(), "process", null, 1, 1, TRCClassLoader.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCClassLoader_ClassLoaderInstance(), this.getTRCObject(), null, "classLoaderInstance", null, 1, 1, TRCClassLoader.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcSourceInfoEClass, TRCSourceInfo.class, "TRCSourceInfo", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCSourceInfo_Location(), ecorePackage.getEString(), "location", null, 0, 1, TRCSourceInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCSourceInfo_Language(), ecorePackage.getEString(), "language", null, 0, 1, TRCSourceInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcHeapObjectEClass, TRCHeapObject.class, "TRCHeapObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCHeapObject_RefOwner(), this.getTRCObjectReference(), this.getTRCObjectReference_Owner(), "refOwner", null, 0, -1, TRCHeapObject.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapObject_RefTarget(), this.getTRCObjectReference(), this.getTRCObjectReference_Target(), "refTarget", null, 0, -1, TRCHeapObject.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcFullTraceObjectEClass, TRCFullTraceObject.class, "TRCFullTraceObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCFullTraceObject_CreateTime(), ecorePackage.getEDouble(), "createTime", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullTraceObject_CollectTime(), ecorePackage.getEDouble(), "collectTime", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullTraceObject_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullTraceObject_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullTraceObject_Calls(), ecorePackage.getEInt(), "calls", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCFullTraceObject_ObjAllocSite(), this.getTRCObjAllocSite(), null, "objAllocSite", null, 0, 1, TRCFullTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcTraceObjectEClass, TRCTraceObject.class, "TRCTraceObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCTraceObject_Invocations(), this.getTRCMethodInvocation(), null, "invocations", null, 0, -1, TRCTraceObject.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCTraceObject_Thread(), this.getTRCThread(), null, "thread", null, 0, 1, TRCTraceObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcFullHeapObjectEClass, TRCFullHeapObject.class, "TRCFullHeapObject", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCFullHeapObject_HeapDumpFirstSeen(), ecorePackage.getEShort(), "heapDumpFirstSeen", null, 0, 1, TRCFullHeapObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcMemoryStatsManagerEClass, TRCMemoryStatsManager.class, "TRCMemoryStatsManager", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCMemoryStatsManager_NumFullMethInvocObjs(), theEcorePackage.getELong(), "numFullMethInvocObjs", null, 0, 1, TRCMemoryStatsManager.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMemoryStatsManager_NumAggMethInvocObjs(), theEcorePackage.getELong(), "numAggMethInvocObjs", null, 0, 1, TRCMemoryStatsManager.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCMemoryStatsManager_NumHeapObjs(), theEcorePackage.getELong(), "numHeapObjs", null, 0, 1, TRCMemoryStatsManager.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcObjectReferenceEClass, TRCObjectReference.class, "TRCObjectReference", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCObjectReference_HeapDump(), this.getTRCHeapDump(), this.getTRCHeapDump_References(), "heapDump", null, 1, 1, TRCObjectReference.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjectReference_Owner(), this.getTRCHeapObject(), this.getTRCHeapObject_RefOwner(), "owner", null, 1, 1, TRCObjectReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjectReference_Target(), this.getTRCHeapObject(), this.getTRCHeapObject_RefTarget(), "target", null, 1, 1, TRCObjectReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcHeapDumpEClass, TRCHeapDump.class, "TRCHeapDump", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCHeapDump_Id(), ecorePackage.getEShort(), "id", null, 0, 1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCHeapDump_EntryTime(), ecorePackage.getEDouble(), "entryTime", null, 0, 1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCHeapDump_ExitTime(), ecorePackage.getEDouble(), "exitTime", null, 0, 1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCHeapDump_Name(), ecorePackage.getEString(), "name", null, 0, 1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapDump_References(), this.getTRCObjectReference(), this.getTRCObjectReference_HeapDump(), "references", null, 0, -1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapDump_Process(), this.getTRCProcess(), this.getTRCProcess_HeapDumps(), "process", null, 0, 1, TRCHeapDump.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapDump_GcRoots(), this.getTRCHeapRoot(), this.getTRCHeapRoot_HeapDump(), "gcRoots", null, 0, -1, TRCHeapDump.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcAggregatedMethodInvocationEClass, TRCAggregatedMethodInvocation.class, "TRCAggregatedMethodInvocation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCAggregatedMethodInvocation_Count(), ecorePackage.getEInt(), "count", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_BaseTime(), ecorePackage.getEDouble(), "baseTime", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_CumulativeTime(), ecorePackage.getEDouble(), "cumulativeTime", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_MinTime(), ecorePackage.getEDouble(), "minTime", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_MaxTime(), ecorePackage.getEDouble(), "maxTime", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_CallerLineNo(), ecorePackage.getEInt(), "callerLineNo", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedMethodInvocation_TotalCpuTime(), ecorePackage.getEDouble(), "totalCpuTime", null, 0, 1, TRCAggregatedMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcFullMethodInvocationEClass, TRCFullMethodInvocation.class, "TRCFullMethodInvocation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCFullMethodInvocation_StackDepth(), ecorePackage.getEShort(), "stackDepth", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_EntryTime(), ecorePackage.getEDouble(), "entryTime", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_ExitTime(), ecorePackage.getEDouble(), "exitTime", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_Ticket(), ecorePackage.getELong(), "ticket", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_Overhead(), ecorePackage.getEDouble(), "overhead", "0.0", 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_CallerLineNo(), ecorePackage.getEInt(), "callerLineNo", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_CpuTime(), ecorePackage.getEDouble(), "cpuTime", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_OrigEntryTime(), theEcorePackage.getEDouble(), "origEntryTime", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCFullMethodInvocation_OrigExitTime(), theEcorePackage.getEDouble(), "origExitTime", null, 0, 1, TRCFullMethodInvocation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcHeapRootEClass, TRCHeapRoot.class, "TRCHeapRoot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCHeapRoot_Type(), this.getTRCGCRootType(), "type", null, 0, 1, TRCHeapRoot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCHeapRoot_Frame(), ecorePackage.getEInt(), "frame", "-1", 0, 1, TRCHeapRoot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapRoot_HeapDump(), this.getTRCHeapDump(), this.getTRCHeapDump_GcRoots(), "heapDump", null, 1, 1, TRCHeapRoot.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapRoot_Thread(), this.getTRCThread(), null, "thread", null, 0, 1, TRCHeapRoot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCHeapRoot_Object(), this.getTRCObject(), null, "object", null, 0, 1, TRCHeapRoot.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcArrayClassEClass, TRCArrayClass.class, "TRCArrayClass", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCArrayClass_ArrayType(), this.getTRCPrimitiveType(), "arrayType", null, 0, 1, TRCArrayClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCArrayClass_ElementType(), this.getTRCClass(), null, "elementType", null, 0, 1, TRCArrayClass.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcAggregatedObjectReferenceEClass, TRCAggregatedObjectReference.class, "TRCAggregatedObjectReference", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCAggregatedObjectReference_OwnerSize(), ecorePackage.getEInt(), "ownerSize", null, 0, 1, TRCAggregatedObjectReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedObjectReference_TargetSize(), ecorePackage.getEInt(), "targetSize", null, 0, 1, TRCAggregatedObjectReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCAggregatedObjectReference_Count(), ecorePackage.getEInt(), "count", null, 0, 1, TRCAggregatedObjectReference.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadEventEClass, TRCThreadEvent.class, "TRCThreadEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCThreadEvent_Time(), ecorePackage.getEDouble(), "time", null, 0, 1, TRCThreadEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThreadEvent_TraceOrder(), theEcorePackage.getELong(), "traceOrder", null, 0, 1, TRCThreadEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThreadEvent_Thread(), this.getTRCThread(), this.getTRCThread_ThreadEvents(), "thread", null, 1, 1, TRCThreadEvent.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThreadEvent_Annotations(), theHierarchyPackage.getTRCAnnotation(), null, "annotations", null, 0, -1, TRCThreadEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadSleepingEventEClass, TRCThreadSleepingEvent.class, "TRCThreadSleepingEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCThreadSleepingEvent_SleepingTime(), ecorePackage.getELong(), "sleepingTime", null, 0, 1, TRCThreadSleepingEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadWaitingForObjectEventEClass, TRCThreadWaitingForObjectEvent.class, "TRCThreadWaitingForObjectEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCThreadWaitingForObjectEvent_Timeout(), ecorePackage.getELong(), "timeout", null, 0, 1, TRCThreadWaitingForObjectEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThreadWaitingForObjectEvent_ObjectWaitingFor(), this.getTRCObject(), null, "objectWaitingFor", null, 1, 1, TRCThreadWaitingForObjectEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadWaitingForLockEventEClass, TRCThreadWaitingForLockEvent.class, "TRCThreadWaitingForLockEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadWaitingForLockEvent_LockedObject(), this.getTRCObject(), null, "lockedObject", null, 1, 1, TRCThreadWaitingForLockEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCThreadWaitingForLockEvent_LockingThread(), this.getTRCThread(), null, "lockingThread", null, 1, 1, TRCThreadWaitingForLockEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadRunningEventEClass, TRCThreadRunningEvent.class, "TRCThreadRunningEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadDeadEventEClass, TRCThreadDeadEvent.class, "TRCThreadDeadEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcMethodWithLLDataEClass, TRCMethodWithLLData.class, "TRCMethodWithLLData", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCMethodWithLLData_LLData(), this.getTRCLLData(), this.getTRCLLData_Method(), "LLData", null, 0, 1, TRCMethodWithLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcllDataEClass, TRCLLData.class, "TRCLLData", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCLLData_SummaryUnits(), ecorePackage.getEInt(), "summaryUnits", null, 0, 1, TRCLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLLData_SummaryNonzero(), ecorePackage.getEInt(), "summaryNonzero", null, 0, 1, TRCLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLLData_TypeId(), ecorePackage.getEString(), "typeId", null, 0, 1, TRCLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLLData_Headings(), ecorePackage.getEString(), "headings", null, 0, 1, TRCLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCLLData_Method(), this.getTRCMethodWithLLData(), this.getTRCMethodWithLLData_LLData(), "method", null, 1, 1, TRCLLData.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(trcllDataEClass, ecorePackage.getEInt(), "getUnitCount", 0, 1, IS_UNIQUE, IS_ORDERED);

		EOperation op = addEOperation(trcllDataEClass, this.getLLUnitData(), "getUnitData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "unitNumber", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getLLUnitData(), "instance", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcllDataEClass, ecorePackage.getEBoolean(), "hasCountInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcllDataEClass, ecorePackage.getEBoolean(), "hasAccumulatedTimeInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(trcSourceInfoWithLLDataEClass, TRCSourceInfoWithLLData.class, "TRCSourceInfoWithLLData", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCSourceInfoWithLLData_LLDatas(), this.getTRCLLData(), null, "LLDatas", null, 0, -1, TRCSourceInfoWithLLData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcLineCoverageDataEClass, TRCLineCoverageData.class, "TRCLineCoverageData", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCLineCoverageData_LineTable(), theHierarchyPackage.getIntArray(), "lineTable", null, 0, 1, TRCLineCoverageData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLineCoverageData_HitTable(), theHierarchyPackage.getBooleanArray(), "hitTable", null, 0, 1, TRCLineCoverageData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLineCoverageData_CountTable(), theHierarchyPackage.getIntArray(), "countTable", null, 0, 1, TRCLineCoverageData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCLineCoverageData_SourceInfo(), this.getTRCSourceInfoWithLLData(), null, "sourceInfo", null, 0, 1, TRCLineCoverageData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(trcLineCoverageDataEClass, ecorePackage.getEInt(), "getUnitCount", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(trcLineCoverageDataEClass, this.getLLUnitData(), "getUnitData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "unitNumber", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getLLUnitData(), "instance", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcLineCoverageDataEClass, ecorePackage.getEBoolean(), "hasCountInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcLineCoverageDataEClass, ecorePackage.getEBoolean(), "hasAccumulatedTimeInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(trcObjectValueEClass, TRCObjectValue.class, "TRCObjectValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCObjectValue_StringValue(), ecorePackage.getEString(), "stringValue", null, 0, 1, TRCObjectValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjectValue_TRCInputOutputEntry(), this.getTRCInputOutputEntry(), this.getTRCInputOutputEntry_Value(), "TRCInputOutputEntry", null, 0, 1, TRCObjectValue.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjectValue_Container(), this.getTRCInputOutputContainer(), this.getTRCInputOutputContainer_InputOutputValues(), "container", null, 0, 1, TRCObjectValue.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcInputOutputEntryEClass, Map.Entry.class, "TRCInputOutputEntry", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCInputOutputEntry_Value(), this.getTRCObjectValue(), this.getTRCObjectValue_TRCInputOutputEntry(), "value", null, 0, -1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCInputOutputEntry_Container(), this.getTRCInputOutputContainer(), this.getTRCInputOutputContainer_Entries(), "container", null, 1, 1, Map.Entry.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCInputOutputEntry_Key(), this.getTRCMethodInvocation(), null, "key", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcInputOutputContainerEClass, TRCInputOutputContainer.class, "TRCInputOutputContainer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCInputOutputContainer_Process(), this.getTRCProcess(), this.getTRCProcess_InputOutputContainer(), "process", null, 1, 1, TRCInputOutputContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCInputOutputContainer_Entries(), this.getTRCInputOutputEntry(), this.getTRCInputOutputEntry_Container(), "entries", null, 0, -1, TRCInputOutputContainer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCInputOutputContainer_InputOutputValues(), this.getTRCObjectValue(), this.getTRCObjectValue_Container(), "inputOutputValues", null, 0, -1, TRCInputOutputContainer.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcCallerCalleeInvocationInfoEClass, TRCCallerCalleeInvocationInfo.class, "TRCCallerCalleeInvocationInfo", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCCallerCalleeInvocationInfo_CallTime(), ecorePackage.getEDouble(), "callTime", null, 0, 1, TRCCallerCalleeInvocationInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCCallerCalleeInvocationInfo_ReturnTime(), ecorePackage.getEDouble(), "returnTime", null, 0, 1, TRCCallerCalleeInvocationInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCCallerCalleeInvocationInfo_CallOverhead(), ecorePackage.getEDouble(), "callOverhead", "0.0", 0, 1, TRCCallerCalleeInvocationInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcTypedObjectValueEClass, TRCTypedObjectValue.class, "TRCTypedObjectValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCTypedObjectValue_ValueKind(), this.getTRCObjectValueKind(), "valueKind", null, 0, 1, TRCTypedObjectValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCTypedObjectValue_PositionKind(), this.getTRCObjectValuePosition(), "positionKind", null, 0, 1, TRCTypedObjectValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCTypedObjectValue_Position(), ecorePackage.getEShort(), "position", null, 0, 1, TRCTypedObjectValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCTypedObjectValue_Object(), this.getTRCTraceObject(), null, "object", null, 0, 1, TRCTypedObjectValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcMthdLckAccEntryEClass, Map.Entry.class, "TRCMthdLckAccEntry", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCMthdLckAccEntry_Process(), this.getTRCProcess(), this.getTRCProcess_MethodLockAccessEntries(), "process", null, 1, 1, Map.Entry.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMthdLckAccEntry_Value(), this.getTRCLockAccess(), null, "value", null, 1, -1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCMthdLckAccEntry_Key(), this.getTRCMethodInvocation(), null, "key", null, 1, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcLockAccessEClass, TRCLockAccess.class, "TRCLockAccess", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCLockAccess_RequireTime(), ecorePackage.getEDouble(), "requireTime", null, 0, 1, TRCLockAccess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLockAccess_RequestTime(), ecorePackage.getEDouble(), "requestTime", null, 0, 1, TRCLockAccess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLockAccess_ReleaseTime(), ecorePackage.getEDouble(), "releaseTime", null, 0, 1, TRCLockAccess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCLockAccess_AtLine(), ecorePackage.getEInt(), "atLine", null, 0, 1, TRCLockAccess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCLockAccess_OnObject(), this.getTRCObject(), null, "onObject", null, 0, 1, TRCLockAccess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcLinePerformanceDataEClass, TRCLinePerformanceData.class, "TRCLinePerformanceData", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTRCLinePerformanceData_AccumulatedTimeTable(), theHierarchyPackage.getDoubleArray(), "accumulatedTimeTable", null, 0, 1, TRCLinePerformanceData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(trcLinePerformanceDataEClass, this.getLLUnitData(), "getUnitData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "unitNumber", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getLLUnitData(), "instance", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcLinePerformanceDataEClass, ecorePackage.getEBoolean(), "hasCountInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(trcLinePerformanceDataEClass, ecorePackage.getEBoolean(), "hasAccumulatedTimeInfo", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(trcThreadDeadLockEventEClass, TRCThreadDeadLockEvent.class, "TRCThreadDeadLockEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadDeadLockEvent_NextDeadLockEvent(), this.getTRCThreadDeadLockEvent(), null, "nextDeadLockEvent", null, 0, 1, TRCThreadDeadLockEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcLanguageElementEClass, TRCLanguageElement.class, "TRCLanguageElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCLanguageElement_SourceInfo(), this.getTRCSourceInfo(), null, "sourceInfo", null, 0, 1, TRCLanguageElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCLanguageElement_Annotations(), theHierarchyPackage.getTRCAnnotation(), null, "annotations", null, 0, -1, TRCLanguageElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcObjectAllocationAnnotationEClass, TRCObjectAllocationAnnotation.class, "TRCObjectAllocationAnnotation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCObjectAllocationAnnotation_Methods(), this.getTRCMethod(), null, "methods", null, 0, -1, TRCObjectAllocationAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjectAllocationAnnotation_Classes(), this.getTRCClass(), null, "classes", null, 0, -1, TRCObjectAllocationAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObjectAllocationAnnotation_LineNumbers(), ecorePackage.getEInt(), "lineNumbers", null, 0, -1, TRCObjectAllocationAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObjectAllocationAnnotation_CreateTimes(), theEcorePackage.getEDouble(), "createTimes", null, 0, -1, TRCObjectAllocationAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadWaitTimeoutExceedEventEClass, TRCThreadWaitTimeoutExceedEvent.class, "TRCThreadWaitTimeoutExceedEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadWaitingForJoinEventEClass, TRCThreadWaitingForJoinEvent.class, "TRCThreadWaitingForJoinEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadExecEventEClass, TRCThreadExecEvent.class, "TRCThreadExecEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadExecEvent_RunningEvents(), this.getTRCThreadRunningEvent(), null, "runningEvents", null, 1, -1, TRCThreadExecEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCThreadExecEvent_InCriticalPath(), ecorePackage.getEBoolean(), "inCriticalPath", null, 0, 1, TRCThreadExecEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadNotifyAllEventEClass, TRCThreadNotifyAllEvent.class, "TRCThreadNotifyAllEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadNotifyEventEClass, TRCThreadNotifyEvent.class, "TRCThreadNotifyEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadDeadAndNotifyJoinedEventEClass, TRCThreadDeadAndNotifyJoinedEvent.class, "TRCThreadDeadAndNotifyJoinedEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(trcThreadStartThreadEventEClass, TRCThreadStartThreadEvent.class, "TRCThreadStartThreadEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadStartThreadEvent_StartedThread(), this.getTRCThread(), null, "startedThread", null, 0, 1, TRCThreadStartThreadEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadInterruptThreadEventEClass, TRCThreadInterruptThreadEvent.class, "TRCThreadInterruptThreadEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadInterruptThreadEvent_InterruptedThread(), this.getTRCThread(), null, "interruptedThread", null, 0, 1, TRCThreadInterruptThreadEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcThreadHandoffLockEventEClass, TRCThreadHandoffLockEvent.class, "TRCThreadHandoffLockEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCThreadHandoffLockEvent_LockedObject(), this.getTRCObject(), null, "lockedObject", null, 1, 1, TRCThreadHandoffLockEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trcObjAllocSiteEClass, TRCObjAllocSite.class, "TRCObjAllocSite", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTRCObjAllocSite_Method(), this.getTRCMethod(), null, "method", null, 1, 1, TRCObjAllocSite.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTRCObjAllocSite_Class(), this.getTRCClass(), this.getTRCClass_AllocationSites(), "class", null, 1, 1, TRCObjAllocSite.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObjAllocSite_LineNumber(), theEcorePackage.getEInt(), "lineNumber", null, 1, 1, TRCObjAllocSite.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTRCObjAllocSite_ObjectsCreated(), theEcorePackage.getELong(), "objectsCreated", "0", 1, 1, TRCObjAllocSite.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(trcPrimitiveTypeEEnum, TRCPrimitiveType.class, "TRCPrimitiveType");
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_REFERENCE_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_BOOLEAN_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_BYTE_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_CHAR_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_SHORT_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_INT_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_LONG_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_FLOAT_LITERAL);
		addEEnumLiteral(trcPrimitiveTypeEEnum, TRCPrimitiveType.JAVA_DOUBLE_LITERAL);

		initEEnum(trcSignatureNotationEEnum, TRCSignatureNotation.class, "TRCSignatureNotation");
		addEEnumLiteral(trcSignatureNotationEEnum, TRCSignatureNotation.JNI_LITERAL);

		initEEnum(trcMethodPropertiesEEnum, TRCMethodProperties.class, "TRCMethodProperties");
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_NATIVE_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_SYNCHRONIZED_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_PUBLIC_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_PRIVATE_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_PROTECTED_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_DEFAULT_VISIBILITY_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_STATIC_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_CONSTRUCTOR_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_ABSTRACT_LITERAL);
		addEEnumLiteral(trcMethodPropertiesEEnum, TRCMethodProperties.JAVA_FINALIZER_LITERAL);

		initEEnum(trcgcRootTypeEEnum, TRCGCRootType.class, "TRCGCRootType");
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.UNKNOWN_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.JNI_GLOBAL_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.JNI_LOCAL_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.JAVA_FRAME_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.NATIVE_STACK_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.STICKY_CLASS_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.THREAD_BLOCK_LITERAL);
		addEEnumLiteral(trcgcRootTypeEEnum, TRCGCRootType.MONITOR_USED_LITERAL);

		initEEnum(trcObjectValueKindEEnum, TRCObjectValueKind.class, "TRCObjectValueKind");
		addEEnumLiteral(trcObjectValueKindEEnum, TRCObjectValueKind.THIS_LITERAL);
		addEEnumLiteral(trcObjectValueKindEEnum, TRCObjectValueKind.AGGREGATED_LITERAL);
		addEEnumLiteral(trcObjectValueKindEEnum, TRCObjectValueKind.QUERY_LITERAL);
		addEEnumLiteral(trcObjectValueKindEEnum, TRCObjectValueKind.PROTOCOL_LITERAL);
		addEEnumLiteral(trcObjectValueKindEEnum, TRCObjectValueKind.EXCEPTION_LITERAL);

		initEEnum(trcObjectValuePositionEEnum, TRCObjectValuePosition.class, "TRCObjectValuePosition");
		addEEnumLiteral(trcObjectValuePositionEEnum, TRCObjectValuePosition.BEFORE_LITERAL);
		addEEnumLiteral(trcObjectValuePositionEEnum, TRCObjectValuePosition.AFTER_LITERAL);
		addEEnumLiteral(trcObjectValuePositionEEnum, TRCObjectValuePosition.EXIT_LITERAL);

		// Initialize data types
		initEDataType(eObjectIDEDataType, long.class, "EObjectID", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(eMethodIDEDataType, int.class, "EMethodID", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(eClassIDEDataType, long.class, "EClassID", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(llUnitDataEDataType, LLUnitData.class, "LLUnitData", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// @extends
		create_extendsAnnotations();
		// org.eclipse.hyades.loaders.trace.IDeltaManager
		createOrgAnnotations();
	}

	/**
	 * Initializes the annotations for <b>@extends</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void create_extendsAnnotations() {
		String source = "@extends";																																			
		addAnnotation
		  (trcProcessEClass, 
		   source, 
		   new String[] {
		   });																																					
		addAnnotation
		  (trcMethodEClass, 
		   source, 
		   new String[] {
		   });																		
		addAnnotation
		  (trcPackageEClass, 
		   source, 
		   new String[] {
		   });																																																																														
	}

	/**
	 * Initializes the annotations for <b>org.eclipse.hyades.loaders.trace.IDeltaManager</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createOrgAnnotations() {
		String source = "org.eclipse.hyades.loaders.trace.IDeltaManager";																																				
		addAnnotation
		  (trcProcessEClass, 
		   source, 
		   new String[] {
		   });																																					
		addAnnotation
		  (trcMethodEClass, 
		   source, 
		   new String[] {
		   });																		
		addAnnotation
		  (trcPackageEClass, 
		   source, 
		   new String[] {
		   });																																																																													
	}

} //TracePackageImpl
